/* CryptTabEntry.c generated by valac 0.40.6, the Vala compiler
 * generated from CryptTabEntry.vala, do not modify */

/*
 * CryptTabEntry.vala
 *
 * Copyright 2016 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_CRYPT_TAB_ENTRY (crypt_tab_entry_get_type ())
#define CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntry))
#define CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))
#define IS_CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRYPT_TAB_ENTRY))
#define IS_CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRYPT_TAB_ENTRY))
#define CRYPT_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))

typedef struct _CryptTabEntry CryptTabEntry;
typedef struct _CryptTabEntryClass CryptTabEntryClass;
typedef struct _CryptTabEntryPrivate CryptTabEntryPrivate;
enum  {
	CRYPT_TAB_ENTRY_0_PROPERTY,
	CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY,
	CRYPT_TAB_ENTRY_NUM_PROPERTIES
};
static GParamSpec* crypt_tab_entry_properties[CRYPT_TAB_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CryptTabEntry {
	GObject parent_instance;
	CryptTabEntryPrivate * priv;
	gboolean is_comment;
	gboolean is_empty_line;
	gchar* mapped_name;
	gchar* device_string;
	gchar* keyfile;
	gchar* options;
	gchar* line;
};

struct _CryptTabEntryClass {
	GObjectClass parent_class;
};


static gpointer crypt_tab_entry_parent_class = NULL;

GType crypt_tab_entry_get_type (void) G_GNUC_CONST;
GeeArrayList* crypt_tab_entry_read_file (const gchar* file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
CryptTabEntry* crypt_tab_entry_new (void);
CryptTabEntry* crypt_tab_entry_construct (GType object_type);
gchar* crypt_tab_entry_write_file (GeeArrayList* entries,
                                   const gchar* file_path,
                                   gboolean keep_comments_and_empty_lines);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
void crypt_tab_entry_append_option (CryptTabEntry* self,
                                    const gchar* option);
void crypt_tab_entry_remove_option (CryptTabEntry* self,
                                    const gchar* option);
CryptTabEntry* crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries,
                                                   const gchar* uuid);
gchar* crypt_tab_entry_get_device_uuid (CryptTabEntry* self);
void crypt_tab_entry_set_device_uuid (CryptTabEntry* self,
                                      const gchar* value);
static void crypt_tab_entry_finalize (GObject * obj);
static void _vala_crypt_tab_entry_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_crypt_tab_entry_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 136 "CryptTabEntry.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 159 "CryptTabEntry.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 163 "CryptTabEntry.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 169 "CryptTabEntry.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 173 "CryptTabEntry.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 177 "CryptTabEntry.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 185 "CryptTabEntry.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 213 "CryptTabEntry.c"
				goto __catch40_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 222 "CryptTabEntry.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 236 "CryptTabEntry.c"
				goto __catch40_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 247 "CryptTabEntry.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 261 "CryptTabEntry.c"
	}
	goto __finally40;
	__catch40_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 275 "CryptTabEntry.c"
	}
	__finally40:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 286 "CryptTabEntry.c"
	}
}


GeeArrayList*
crypt_tab_entry_read_file (const gchar* file_path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	gchar** lines = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = gee_array_list_new (TYPE_CRYPT_TAB_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	list = _tmp0_;
#line 61 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (!tee_jee_file_system_file_exists (file_path)) {
#line 61 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		result = list;
#line 61 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		return result;
#line 319 "CryptTabEntry.c"
	}
#line 63 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp1_ = tee_jee_file_system_file_read (file_path);
#line 63 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	text = _tmp1_;
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp2_ = text;
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	lines = _tmp4_;
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	lines_length1 = _vala_array_length (_tmp3_);
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_lines_size_ = lines_length1;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp5_ = lines;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp5__length1 = lines_length1;
#line 339 "CryptTabEntry.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		line_collection = _tmp5_;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		line_collection_length1 = _tmp5__length1;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		for (line_it = 0; line_it < _tmp5__length1; line_it = line_it + 1) {
#line 351 "CryptTabEntry.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			line = _tmp6_;
#line 358 "CryptTabEntry.c"
			{
				CryptTabEntry* entry = NULL;
				CryptTabEntry* _tmp7_;
				GeeArrayList* _tmp8_;
				CryptTabEntry* _tmp9_;
				CryptTabEntry* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				CryptTabEntry* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				CryptTabEntry* _tmp20_;
				gboolean _tmp21_;
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp7_ = crypt_tab_entry_new ();
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				entry = _tmp7_;
#line 67 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp8_ = list;
#line 67 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp9_ = entry;
#line 67 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp10_ = entry;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp11_ = line;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp12_ = string_strip (_tmp11_);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp13_ = _tmp12_;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp10_->is_comment = g_str_has_prefix (_tmp13_, "#");
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp13_);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp14_ = entry;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp15_ = line;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp16_ = string_strip (_tmp15_);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp17_ = _tmp16_;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp18_ = strlen (_tmp17_);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp19_ = _tmp18_;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp14_->is_empty_line = _tmp19_ == 0;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp17_);
#line 72 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp20_ = entry;
#line 72 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp21_ = _tmp20_->is_comment;
#line 72 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				if (_tmp21_) {
#line 420 "CryptTabEntry.c"
					CryptTabEntry* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp22_ = entry;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp23_ = line;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_g_free0 (_tmp22_->line);
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp22_->line = _tmp24_;
#line 434 "CryptTabEntry.c"
				} else {
					CryptTabEntry* _tmp25_;
					gboolean _tmp26_;
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp25_ = entry;
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp26_ = _tmp25_->is_empty_line;
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					if (_tmp26_) {
#line 444 "CryptTabEntry.c"
						CryptTabEntry* _tmp27_;
						gchar* _tmp28_;
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp27_ = entry;
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp28_ = g_strdup ("");
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp27_->line);
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp27_->line = _tmp28_;
#line 455 "CryptTabEntry.c"
					} else {
						CryptTabEntry* _tmp29_;
						const gchar* _tmp30_;
						gchar* _tmp31_;
						gchar** parts = NULL;
						const gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						gchar** _tmp35_;
						gchar** _tmp36_;
						gchar** _tmp37_;
						gint _tmp37__length1;
						gint parts_length1;
						gint _parts_size_;
						gint part_num = 0;
						gchar** _tmp38_;
						gint _tmp38__length1;
#line 79 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp29_ = entry;
#line 79 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp30_ = line;
#line 79 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp31_ = g_strdup (_tmp30_);
#line 79 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp29_->line);
#line 79 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp29_->line = _tmp31_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp32_ = line;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp33_ = string_replace (_tmp32_, "\t", " ");
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp34_ = _tmp33_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp36_ = _tmp35_ = g_strsplit (_tmp34_, " ", 0);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp37_ = _tmp36_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp37__length1 = _vala_array_length (_tmp35_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp34_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						parts = _tmp37_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						parts_length1 = _tmp37__length1;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_parts_size_ = parts_length1;
#line 82 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						part_num = -1;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp38_ = parts;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						_tmp38__length1 = parts_length1;
#line 509 "CryptTabEntry.c"
						{
							gchar** part_collection = NULL;
							gint part_collection_length1 = 0;
							gint _part_collection_size_ = 0;
							gint part_it = 0;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
							part_collection = _tmp38_;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
							part_collection_length1 = _tmp38__length1;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
							for (part_it = 0; part_it < _tmp38__length1; part_it = part_it + 1) {
#line 521 "CryptTabEntry.c"
								gchar* _tmp39_;
								gchar* part = NULL;
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
								_tmp39_ = g_strdup (part_collection[part_it]);
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
								part = _tmp39_;
#line 528 "CryptTabEntry.c"
								{
									const gchar* _tmp40_;
									gchar* _tmp41_;
									gchar* _tmp42_;
									gint _tmp43_;
									gint _tmp44_;
									gboolean _tmp45_;
									gint _tmp46_;
									gint _tmp47_;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp40_ = part;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp41_ = string_strip (_tmp40_);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp42_ = _tmp41_;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp43_ = strlen (_tmp42_);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp44_ = _tmp43_;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp45_ = _tmp44_ == 0;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_g_free0 (_tmp42_);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									if (_tmp45_) {
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										_g_free0 (part);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										continue;
#line 558 "CryptTabEntry.c"
									}
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp46_ = part_num;
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									part_num = _tmp46_ + 1;
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_tmp47_ = part_num;
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									switch (_tmp47_) {
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										case 0:
#line 570 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp48_;
											const gchar* _tmp49_;
											gchar* _tmp50_;
#line 87 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp48_ = entry;
#line 87 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp49_ = part;
#line 87 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp50_ = string_strip (_tmp49_);
#line 87 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp48_->mapped_name);
#line 87 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp48_->mapped_name = _tmp50_;
#line 88 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											break;
#line 587 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										case 1:
#line 591 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp51_;
											const gchar* _tmp52_;
											gchar* _tmp53_;
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp51_ = entry;
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp52_ = part;
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp53_ = string_strip (_tmp52_);
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp51_->device_string);
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp51_->device_string = _tmp53_;
#line 91 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											break;
#line 608 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										case 2:
#line 612 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp54_;
											const gchar* _tmp55_;
											gchar* _tmp56_;
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp54_ = entry;
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp55_ = part;
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp56_ = string_strip (_tmp55_);
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp54_->keyfile);
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp54_->keyfile = _tmp56_;
#line 94 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											break;
#line 629 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										case 3:
#line 633 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp57_;
											const gchar* _tmp58_;
											gchar* _tmp59_;
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp57_ = entry;
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp58_ = part;
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp59_ = string_strip (_tmp58_);
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp57_->options);
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											_tmp57_->options = _tmp59_;
#line 97 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
											break;
#line 650 "CryptTabEntry.c"
										}
										default:
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
										break;
#line 655 "CryptTabEntry.c"
									}
#line 83 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
									_g_free0 (part);
#line 659 "CryptTabEntry.c"
								}
							}
						}
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 665 "CryptTabEntry.c"
					}
				}
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_object_unref0 (entry);
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_free0 (line);
#line 672 "CryptTabEntry.c"
			}
		}
	}
#line 103 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	result = list;
#line 103 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 103 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (text);
#line 103 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return result;
#line 684 "CryptTabEntry.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 693 "CryptTabEntry.c"
}


gchar*
crypt_tab_entry_write_file (GeeArrayList* entries,
                            const gchar* file_path,
                            gboolean keep_comments_and_empty_lines)
{
	gchar* result = NULL;
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp34_;
#line 106 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 106 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 110 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 110 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	text = _tmp0_;
#line 714 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp1_;
		gint _entry_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp1_ = _g_object_ref0 (entries);
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_list = _tmp1_;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp2_ = _entry_list;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp4_ = _tmp3_;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_size = _tmp4_;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 739 "CryptTabEntry.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			CryptTabEntry* _tmp12_;
			gboolean _tmp13_;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp5_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_entry_index = _tmp5_ + 1;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp6_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp7_ = _entry_size;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				break;
#line 762 "CryptTabEntry.c"
			}
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp8_ = _entry_list;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp9_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp10_;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp12_ = entry;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp13_ = _tmp12_->is_comment;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			if (_tmp13_) {
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp11_ = TRUE;
#line 780 "CryptTabEntry.c"
			} else {
				CryptTabEntry* _tmp14_;
				gboolean _tmp15_;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp14_ = entry;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp15_ = _tmp14_->is_empty_line;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp11_ = _tmp15_;
#line 790 "CryptTabEntry.c"
			}
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			if (_tmp11_) {
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				if (keep_comments_and_empty_lines) {
#line 796 "CryptTabEntry.c"
					const gchar* _tmp16_;
					CryptTabEntry* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp16_ = text;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp17_ = entry;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp18_ = _tmp17_->line;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp19_ = g_strdup_printf ("%s\n", _tmp18_);
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp20_ = _tmp19_;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_tmp21_ = g_strconcat (_tmp16_, _tmp20_, NULL);
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_g_free0 (text);
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					text = _tmp21_;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
					_g_free0 (_tmp20_);
#line 821 "CryptTabEntry.c"
				}
			} else {
				const gchar* _tmp22_;
				CryptTabEntry* _tmp23_;
				const gchar* _tmp24_;
				CryptTabEntry* _tmp25_;
				const gchar* _tmp26_;
				CryptTabEntry* _tmp27_;
				const gchar* _tmp28_;
				CryptTabEntry* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp22_ = text;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp23_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp24_ = _tmp23_->mapped_name;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp25_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp26_ = _tmp25_->device_string;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp27_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp28_ = _tmp27_->keyfile;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp29_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp30_ = _tmp29_->options;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp31_ = g_strdup_printf ("%s\t%s\t%s\t%s\n", _tmp24_, _tmp26_, _tmp28_, _tmp30_);
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp32_ = _tmp31_;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_tmp33_ = g_strconcat (_tmp22_, _tmp32_, NULL);
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_free0 (text);
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				text = _tmp33_;
#line 118 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp32_);
#line 866 "CryptTabEntry.c"
			}
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 870 "CryptTabEntry.c"
		}
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 874 "CryptTabEntry.c"
	}
#line 124 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (tee_jee_file_system_file_exists (file_path)) {
#line 125 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		tee_jee_file_system_file_delete (file_path);
#line 880 "CryptTabEntry.c"
	}
#line 128 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp34_ = text;
#line 128 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	tee_jee_file_system_file_write (file_path, _tmp34_);
#line 130 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	result = text;
#line 130 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return result;
#line 890 "CryptTabEntry.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 910 "CryptTabEntry.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1369 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1371 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 936 "CryptTabEntry.c"
		glong _tmp2_;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		start = _tmp2_ + start;
#line 942 "CryptTabEntry.c"
	}
#line 1374 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 946 "CryptTabEntry.c"
		glong _tmp3_;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		end = _tmp3_ + end;
#line 952 "CryptTabEntry.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 956 "CryptTabEntry.c"
		glong _tmp5_;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 962 "CryptTabEntry.c"
	} else {
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 966 "CryptTabEntry.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 972 "CryptTabEntry.c"
		glong _tmp7_;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 978 "CryptTabEntry.c"
	} else {
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 982 "CryptTabEntry.c"
	}
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1379 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp8_;
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 994 "CryptTabEntry.c"
}


void
crypt_tab_entry_append_option (CryptTabEntry* self,
                               const gchar* option)
{
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (!string_contains (_tmp0_, option)) {
#line 1014 "CryptTabEntry.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp1_ = self->options;
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp2_ = g_strdup_printf (",%s", option);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		self->options = _tmp4_;
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp3_);
#line 1033 "CryptTabEntry.c"
	}
#line 139 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp5_ = self->options;
#line 139 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (g_str_has_prefix (_tmp5_, ",")) {
#line 1039 "CryptTabEntry.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp6_ = self->options;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp7_ = self->options;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp8_ = strlen (_tmp7_);
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp9_ = _tmp8_;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp10_ = string_slice (_tmp6_, (glong) 1, (glong) _tmp9_);
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		self->options = _tmp10_;
#line 1059 "CryptTabEntry.c"
	}
#line 143 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp11_ = self->options;
#line 143 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 143 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 143 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->options = _tmp12_;
#line 1069 "CryptTabEntry.c"
}


void
crypt_tab_entry_remove_option (CryptTabEntry* self,
                               const gchar* option)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp10_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 146 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 146 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp1_ = string_replace (_tmp0_, option, "");
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->options = _tmp3_;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (_tmp2_);
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp4_ = self->options;
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (g_str_has_prefix (_tmp4_, ",")) {
#line 1107 "CryptTabEntry.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp5_ = self->options;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp6_ = self->options;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp7_ = strlen (_tmp6_);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 1, (glong) _tmp8_);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		self->options = _tmp9_;
#line 1127 "CryptTabEntry.c"
	}
#line 154 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp10_ = self->options;
#line 154 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (g_str_has_suffix (_tmp10_, ",")) {
#line 1133 "CryptTabEntry.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gchar* _tmp15_;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp11_ = self->options;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp12_ = self->options;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp13_ = strlen (_tmp12_);
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp15_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp14_ - 1));
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		self->options = _tmp15_;
#line 1153 "CryptTabEntry.c"
	}
#line 158 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp16_ = self->options;
#line 158 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp17_ = string_strip (_tmp16_);
#line 158 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 158 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->options = _tmp17_;
#line 1163 "CryptTabEntry.c"
}


CryptTabEntry*
crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries,
                                    const gchar* uuid)
{
	CryptTabEntry* result = NULL;
#line 161 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 161 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1176 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp0_;
		gint _entry_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _entry_index = 0;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp0_ = _g_object_ref0 (entries);
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_list = _tmp0_;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp1_ = _entry_list;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_size = _tmp3_;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 1201 "CryptTabEntry.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			CryptTabEntry* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp4_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_entry_index = _tmp4_ + 1;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp5_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp6_ = _entry_size;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				break;
#line 1226 "CryptTabEntry.c"
			}
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp7_ = _entry_list;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp8_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp9_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp10_ = entry;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp11_ = crypt_tab_entry_get_device_uuid (_tmp10_);
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp12_ = _tmp11_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp13_ = _tmp12_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_tmp14_ = g_strcmp0 (_tmp13_, uuid) == 0;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_g_free0 (_tmp13_);
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			if (_tmp14_) {
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				result = entry;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				_g_object_unref0 (_entry_list);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
				return result;
#line 1256 "CryptTabEntry.c"
			}
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 1260 "CryptTabEntry.c"
		}
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 1264 "CryptTabEntry.c"
	}
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	result = NULL;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return result;
#line 1270 "CryptTabEntry.c"
}


CryptTabEntry*
crypt_tab_entry_construct (GType object_type)
{
	CryptTabEntry * self = NULL;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self = (CryptTabEntry*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return self;
#line 1282 "CryptTabEntry.c"
}


CryptTabEntry*
crypt_tab_entry_new (void)
{
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	return crypt_tab_entry_construct (TYPE_CRYPT_TAB_ENTRY);
#line 1291 "CryptTabEntry.c"
}


gchar*
crypt_tab_entry_get_device_uuid (CryptTabEntry* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 45 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->device_string;
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "uuid=");
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (_tmp2_);
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	if (_tmp3_) {
#line 1317 "CryptTabEntry.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp4_ = self->device_string;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp5_ = string_replace (_tmp4_, "\"", "");
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp6_ = _tmp5_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp7_ = string_replace (_tmp6_, "'", "");
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "=", 0);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp11_ = _tmp10_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp11__length1 = _vala_array_length (_tmp9_);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp12_ = _tmp11_[1];
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp8_);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp6_);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		result = _tmp14_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		return result;
#line 1362 "CryptTabEntry.c"
	} else {
		gchar* _tmp15_;
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		_tmp15_ = g_strdup ("");
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		result = _tmp15_;
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		return result;
#line 1371 "CryptTabEntry.c"
	}
}


void
crypt_tab_entry_set_device_uuid (CryptTabEntry* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
#line 53 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup_printf ("UUID=%s", value);
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->device_string = _tmp0_;
#line 53 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY]);
#line 1391 "CryptTabEntry.c"
}


static void
crypt_tab_entry_class_init (CryptTabEntryClass * klass)
{
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	crypt_tab_entry_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_crypt_tab_entry_get_property;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_crypt_tab_entry_set_property;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = crypt_tab_entry_finalize;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY] = g_param_spec_string ("device-uuid", "device-uuid", "device-uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1408 "CryptTabEntry.c"
}


static void
crypt_tab_entry_instance_init (CryptTabEntry * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 34 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->is_comment = FALSE;
#line 35 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->is_empty_line = FALSE;
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->mapped_name = _tmp0_;
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp1_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->device_string = _tmp1_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp2_ = g_strdup ("none");
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->keyfile = _tmp2_;
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp3_ = g_strdup ("luks,nofail");
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->options = _tmp3_;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_tmp4_ = g_strdup ("");
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self->line = _tmp4_;
#line 1444 "CryptTabEntry.c"
}


static void
crypt_tab_entry_finalize (GObject * obj)
{
	CryptTabEntry * self;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->mapped_name);
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->keyfile);
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->line);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (crypt_tab_entry_parent_class)->finalize (obj);
#line 1466 "CryptTabEntry.c"
}


GType
crypt_tab_entry_get_type (void)
{
	static volatile gsize crypt_tab_entry_type_id__volatile = 0;
	if (g_once_init_enter (&crypt_tab_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CryptTabEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crypt_tab_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CryptTabEntry), 0, (GInstanceInitFunc) crypt_tab_entry_instance_init, NULL };
		GType crypt_tab_entry_type_id;
		crypt_tab_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "CryptTabEntry", &g_define_type_info, 0);
		g_once_init_leave (&crypt_tab_entry_type_id__volatile, crypt_tab_entry_type_id);
	}
	return crypt_tab_entry_type_id__volatile;
}


static void
_vala_crypt_tab_entry_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		g_value_take_string (value, crypt_tab_entry_get_device_uuid (self));
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		break;
#line 1500 "CryptTabEntry.c"
		default:
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		break;
#line 1506 "CryptTabEntry.c"
	}
}


static void
_vala_crypt_tab_entry_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		crypt_tab_entry_set_device_uuid (self, g_value_get_string (value));
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		break;
#line 1527 "CryptTabEntry.c"
		default:
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/CryptTabEntry.vala"
		break;
#line 1533 "CryptTabEntry.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



