/* SystemUser.c generated by valac 0.40.6, the Vala compiler
 * generated from SystemUser.vala, do not modify */

/*
 * SystemUser.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_SYSTEM_USER (system_user_get_type ())
#define SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_USER, SystemUser))
#define SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_USER, SystemUserClass))
#define IS_SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_USER))
#define IS_SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_USER))
#define SYSTEM_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_USER, SystemUserClass))

typedef struct _SystemUser SystemUser;
typedef struct _SystemUserClass SystemUserClass;
typedef struct _SystemUserPrivate SystemUserPrivate;
enum  {
	SYSTEM_USER_0_PROPERTY,
	SYSTEM_USER_IS_INSTALLED_PROPERTY,
	SYSTEM_USER_IS_SYSTEM_PROPERTY,
	SYSTEM_USER_GROUP_NAMES_PROPERTY,
	SYSTEM_USER_NUM_PROPERTIES
};
static GParamSpec* system_user_properties[SYSTEM_USER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SystemUser {
	GObject parent_instance;
	SystemUserPrivate * priv;
	gchar* name;
	gchar* password;
	gint uid;
	gint gid;
	gchar* user_info;
	gchar* home_path;
	gchar* shell_path;
	gchar* full_name;
	gchar* room_num;
	gchar* phone_work;
	gchar* phone_home;
	gchar* other_info;
	gchar* shadow_line;
	gchar* pwd_hash;
	gchar* pwd_last_changed;
	gchar* pwd_age_min;
	gchar* pwd_age_max;
	gchar* pwd_warning_period;
	gchar* pwd_inactivity_period;
	gchar* pwd_expiraton_date;
	gchar* reserved_field;
	gboolean has_encrypted_home;
	gboolean has_encrypted_private_dirs;
	GeeArrayList* encrypted_dirs;
	GeeArrayList* encrypted_private_dirs;
	gboolean is_selected;
};

struct _SystemUserClass {
	GObjectClass parent_class;
};


static gpointer system_user_parent_class = NULL;
extern GeeHashMap* system_user_all_users;
GeeHashMap* system_user_all_users = NULL;

GType system_user_get_type (void) G_GNUC_CONST;
SystemUser* system_user_new (const gchar* name);
SystemUser* system_user_construct (GType object_type,
                                   const gchar* name);
void system_user_query_users (gboolean no_passwords);
GeeHashMap* system_user_read_users_from_file (const gchar* passwd_file,
                                              const gchar* shadow_file,
                                              const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                                    const gchar* password);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static SystemUser* system_user_parse_line_passwd (const gchar* line);
static SystemUser* system_user_parse_line_shadow (const gchar* line,
                                           GeeHashMap* list);
void system_user_check_encrypted_dirs (SystemUser* self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gint system_user_add_user (const gchar* user_name,
                           gboolean system_account);
void tee_jee_logging_log_debug (const gchar* message);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gint system_user_add (SystemUser* self);
gboolean system_user_get_is_system (SystemUser* self);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean system_user_update_passwd_file (SystemUser* self);
gchar* system_user_get_passwd_line (SystemUser* self);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean system_user_update_shadow_file (SystemUser* self);
gchar* system_user_get_shadow_line (SystemUser* self);
GeeArrayList* system_user_get_all_users_sorted (void);
static gint _system_user_all_users_sorted___lambda11_ (SystemUser* a,
                                                SystemUser* b);
static gint __system_user_all_users_sorted___lambda11__gcompare_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self);
gboolean system_user_get_is_installed (SystemUser* self);
gchar* system_user_get_group_names (SystemUser* self);
static void system_user_finalize (GObject * obj);
static void _vala_system_user_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


SystemUser*
system_user_construct (GType object_type,
                       const gchar* name)
{
	SystemUser * self = NULL;
	gchar* _tmp0_;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self = (SystemUser*) g_object_new (object_type, NULL);
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup (name);
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->name);
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->name = _tmp0_;
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return self;
#line 172 "SystemUser.c"
}


SystemUser*
system_user_new (const gchar* name)
{
#line 65 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return system_user_construct (TYPE_SYSTEM_USER, name);
#line 181 "SystemUser.c"
}


void
system_user_query_users (gboolean no_passwords)
{
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (no_passwords) {
#line 190 "SystemUser.c"
		GeeHashMap* _tmp0_;
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = system_user_read_users_from_file ("/etc/passwd", "", "");
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (system_user_all_users);
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		system_user_all_users = _tmp0_;
#line 198 "SystemUser.c"
	} else {
		GeeHashMap* _tmp1_;
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = system_user_read_users_from_file ("/etc/passwd", "/etc/shadow", "");
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (system_user_all_users);
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		system_user_all_users = _tmp1_;
#line 207 "SystemUser.c"
	}
}


GeeHashMap*
system_user_read_users_from_file (const gchar* passwd_file,
                                  const gchar* shadow_file,
                                  const gchar* password)
{
	GeeHashMap* result = NULL;
	GeeHashMap* list = NULL;
	GeeHashMap* _tmp0_;
	gchar* txt = NULL;
	gchar* _tmp1_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp23_;
	gint _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	const gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
#line 95 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (passwd_file != NULL, NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (shadow_file != NULL, NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 98 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_SYSTEM_USER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 98 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	list = _tmp0_;
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = g_strdup ("");
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp1_;
#line 104 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (g_str_has_suffix (passwd_file, ".tar.gpg")) {
#line 253 "SystemUser.c"
		gchar* _tmp2_;
#line 105 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = tee_jee_file_system_file_decrypt_untar_read (passwd_file, password);
#line 105 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 105 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp2_;
#line 261 "SystemUser.c"
	} else {
		gchar* _tmp3_;
#line 108 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp3_ = tee_jee_file_system_file_read (passwd_file);
#line 108 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 108 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp3_;
#line 270 "SystemUser.c"
	}
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = txt;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = strlen (_tmp4_);
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = _tmp5_;
#line 111 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp6_ == 0) {
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = list;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 286 "SystemUser.c"
	}
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp7_ = txt;
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "\n", 0);
#line 292 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = _tmp9_;
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp8_);
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp8_); line_it = line_it + 1) {
#line 304 "SystemUser.c"
			gchar* _tmp10_;
			gchar* line = NULL;
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp10_ = g_strdup (line_collection[line_it]);
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line = _tmp10_;
#line 311 "SystemUser.c"
			{
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
				SystemUser* user = NULL;
				const gchar* _tmp16_;
				SystemUser* _tmp17_;
				SystemUser* _tmp18_;
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp12_ = line;
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp12_ == NULL) {
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp11_ = TRUE;
#line 325 "SystemUser.c"
				} else {
					const gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp13_ = line;
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp14_ = strlen (_tmp13_);
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp15_ = _tmp14_;
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp11_ = _tmp15_ == 0;
#line 338 "SystemUser.c"
				}
#line 116 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp11_) {
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					continue;
#line 346 "SystemUser.c"
				}
#line 119 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp16_ = line;
#line 119 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp17_ = system_user_parse_line_passwd (_tmp16_);
#line 119 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				user = _tmp17_;
#line 120 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp18_ = user;
#line 120 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp18_ != NULL) {
#line 358 "SystemUser.c"
					GeeHashMap* _tmp19_;
					SystemUser* _tmp20_;
					const gchar* _tmp21_;
					SystemUser* _tmp22_;
#line 121 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp19_ = list;
#line 121 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp20_ = user;
#line 121 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp21_ = _tmp20_->name;
#line 121 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp22_ = user;
#line 121 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, _tmp21_, _tmp22_);
#line 373 "SystemUser.c"
				}
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_object_unref0 (user);
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (line);
#line 379 "SystemUser.c"
			}
		}
#line 115 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 384 "SystemUser.c"
	}
#line 125 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp23_ = strlen (shadow_file);
#line 125 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp24_ = _tmp23_;
#line 125 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp24_ == 0) {
#line 126 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = list;
#line 126 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 126 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 398 "SystemUser.c"
	}
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp25_ = g_strdup ("");
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp25_;
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (g_str_has_suffix (shadow_file, ".tar.gpg")) {
#line 408 "SystemUser.c"
		gchar* _tmp26_;
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp26_ = tee_jee_file_system_file_decrypt_untar_read (shadow_file, password);
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp26_;
#line 416 "SystemUser.c"
	} else {
		gchar* _tmp27_;
#line 137 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp27_ = tee_jee_file_system_file_read (shadow_file);
#line 137 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 137 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp27_;
#line 425 "SystemUser.c"
	}
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp28_ = txt;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp29_ = strlen (_tmp28_);
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp30_ = _tmp29_;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp30_ == 0) {
#line 141 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = list;
#line 141 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 141 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 441 "SystemUser.c"
	}
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp31_ = txt;
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "\n", 0);
#line 447 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = _tmp33_;
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp32_);
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp32_); line_it = line_it + 1) {
#line 459 "SystemUser.c"
			gchar* _tmp34_;
			gchar* line = NULL;
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp34_ = g_strdup (line_collection[line_it]);
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line = _tmp34_;
#line 466 "SystemUser.c"
			{
				gboolean _tmp35_ = FALSE;
				const gchar* _tmp36_;
				const gchar* _tmp40_;
				GeeHashMap* _tmp41_;
				SystemUser* _tmp42_;
				SystemUser* _tmp43_;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp36_ = line;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp36_ == NULL) {
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp35_ = TRUE;
#line 480 "SystemUser.c"
				} else {
					const gchar* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp37_ = line;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp38_ = strlen (_tmp37_);
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp39_ = _tmp38_;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp35_ = _tmp39_ == 0;
#line 493 "SystemUser.c"
				}
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp35_) {
#line 146 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 146 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					continue;
#line 501 "SystemUser.c"
				}
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp40_ = line;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp41_ = list;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp42_ = system_user_parse_line_shadow (_tmp40_, _tmp41_);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp43_ = _tmp42_;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_object_unref0 (_tmp43_);
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (line);
#line 515 "SystemUser.c"
			}
		}
#line 144 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 520 "SystemUser.c"
	}
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = list;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 528 "SystemUser.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 553 "SystemUser.c"
}


static SystemUser*
system_user_parse_line_passwd (const gchar* line)
{
	SystemUser* result = NULL;
	gboolean _tmp0_ = FALSE;
	SystemUser* user = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 154 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (line == NULL) {
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 576 "SystemUser.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = strlen (line);
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = _tmp1_;
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = _tmp2_ == 0;
#line 586 "SystemUser.c"
	}
#line 155 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp0_) {
#line 156 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = NULL;
#line 156 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 594 "SystemUser.c"
	}
#line 159 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	user = NULL;
#line 162 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 162 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields = _tmp4_;
#line 162 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 162 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_fields_size_ = fields_length1;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = fields;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5__length1 = fields_length1;
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp5__length1 == 7) {
#line 612 "SystemUser.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		SystemUser* _tmp10_;
		SystemUser* _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SystemUser* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		SystemUser* _tmp20_;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		SystemUser* _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		SystemUser* _tmp29_;
		gchar** _tmp30_;
		gint _tmp30__length1;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		SystemUser* _tmp33_;
		gchar** _tmp34_;
		gint _tmp34__length1;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar** arr = NULL;
		SystemUser* _tmp37_;
		const gchar* _tmp38_;
		gchar** _tmp39_;
		gchar** _tmp40_;
		gint arr_length1;
		gint _arr_size_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar** _tmp46_;
		gint _tmp46__length1;
		gchar** _tmp51_;
		gint _tmp51__length1;
		gchar** _tmp56_;
		gint _tmp56__length1;
		gchar** _tmp61_;
		gint _tmp61__length1;
		SystemUser* _tmp66_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6_ = fields;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6__length1 = fields_length1;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp7_ = _tmp6_[0];
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp9_ = _tmp8_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp10_ = system_user_new (_tmp9_);
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		user = _tmp10_;
#line 165 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp9_);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp11_ = user;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp12_ = fields;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp12__length1 = fields_length1;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp13_ = _tmp12_[1];
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp14_ = string_strip (_tmp13_);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp11_->password);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp11_->password = _tmp14_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp15_ = user;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp16_ = fields;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp16__length1 = fields_length1;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp17_ = _tmp16_[2];
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp18_ = string_strip (_tmp17_);
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp19_ = _tmp18_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp15_->uid = atoi (_tmp19_);
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp19_);
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp20_ = user;
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp21_ = fields;
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp21__length1 = fields_length1;
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp22_ = _tmp21_[3];
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp24_ = _tmp23_;
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp20_->gid = atoi (_tmp24_);
#line 168 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp24_);
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp25_ = user;
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp26_ = fields;
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp26__length1 = fields_length1;
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp27_ = _tmp26_[4];
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp28_ = string_strip (_tmp27_);
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp25_->user_info);
#line 169 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp25_->user_info = _tmp28_;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp29_ = user;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp30_ = fields;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp30__length1 = fields_length1;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp31_ = _tmp30_[5];
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp32_ = string_strip (_tmp31_);
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp29_->home_path);
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp29_->home_path = _tmp32_;
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp33_ = user;
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp34_ = fields;
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp34__length1 = fields_length1;
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp35_ = _tmp34_[6];
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp36_ = string_strip (_tmp35_);
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp33_->shell_path);
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp33_->shell_path = _tmp36_;
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp37_ = user;
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp38_ = _tmp37_->user_info;
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, ",", 0);
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		arr = _tmp40_;
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		arr_length1 = _vala_array_length (_tmp39_);
#line 173 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_arr_size_ = arr_length1;
#line 174 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp41_ = arr;
#line 174 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp41__length1 = arr_length1;
#line 174 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (_tmp41__length1 >= 1) {
#line 793 "SystemUser.c"
			SystemUser* _tmp42_;
			gchar** _tmp43_;
			gint _tmp43__length1;
			const gchar* _tmp44_;
			gchar* _tmp45_;
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp42_ = user;
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp43_ = arr;
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp43__length1 = arr_length1;
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp44_ = _tmp43_[0];
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp45_ = g_strdup (_tmp44_);
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp42_->full_name);
#line 175 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp42_->full_name = _tmp45_;
#line 813 "SystemUser.c"
		}
#line 177 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp46_ = arr;
#line 177 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp46__length1 = arr_length1;
#line 177 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (_tmp46__length1 >= 2) {
#line 821 "SystemUser.c"
			SystemUser* _tmp47_;
			gchar** _tmp48_;
			gint _tmp48__length1;
			const gchar* _tmp49_;
			gchar* _tmp50_;
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp47_ = user;
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp48_ = arr;
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp48__length1 = arr_length1;
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp49_ = _tmp48_[1];
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp50_ = g_strdup (_tmp49_);
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp47_->room_num);
#line 178 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp47_->room_num = _tmp50_;
#line 841 "SystemUser.c"
		}
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp51_ = arr;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp51__length1 = arr_length1;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (_tmp51__length1 >= 3) {
#line 849 "SystemUser.c"
			SystemUser* _tmp52_;
			gchar** _tmp53_;
			gint _tmp53__length1;
			const gchar* _tmp54_;
			gchar* _tmp55_;
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp52_ = user;
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp53_ = arr;
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp53__length1 = arr_length1;
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp54_ = _tmp53_[2];
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp55_ = g_strdup (_tmp54_);
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp52_->phone_work);
#line 181 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp52_->phone_work = _tmp55_;
#line 869 "SystemUser.c"
		}
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp56_ = arr;
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp56__length1 = arr_length1;
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (_tmp56__length1 >= 4) {
#line 877 "SystemUser.c"
			SystemUser* _tmp57_;
			gchar** _tmp58_;
			gint _tmp58__length1;
			const gchar* _tmp59_;
			gchar* _tmp60_;
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp57_ = user;
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp58_ = arr;
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp58__length1 = arr_length1;
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp59_ = _tmp58_[3];
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp60_ = g_strdup (_tmp59_);
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp57_->phone_home);
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp57_->phone_home = _tmp60_;
#line 897 "SystemUser.c"
		}
#line 186 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp61_ = arr;
#line 186 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp61__length1 = arr_length1;
#line 186 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (_tmp61__length1 >= 5) {
#line 905 "SystemUser.c"
			SystemUser* _tmp62_;
			gchar** _tmp63_;
			gint _tmp63__length1;
			const gchar* _tmp64_;
			gchar* _tmp65_;
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp62_ = user;
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp63_ = arr;
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp63__length1 = arr_length1;
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp64_ = _tmp63_[4];
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp65_ = g_strdup (_tmp64_);
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp62_->other_info);
#line 187 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp62_->other_info = _tmp65_;
#line 925 "SystemUser.c"
		}
#line 190 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp66_ = user;
#line 190 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		system_user_check_encrypted_dirs (_tmp66_);
#line 164 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 933 "SystemUser.c"
	} else {
		gchar** _tmp67_;
		gint _tmp67__length1;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp67_ = fields;
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp67__length1 = fields_length1;
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp68_ = g_strdup_printf (": %d", _tmp67__length1);
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp69_ = _tmp68_;
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp70_ = g_strconcat ("'passwd' file contains a record with non-standard fields", _tmp69_, NULL);
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp71_ = _tmp70_;
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		tee_jee_logging_log_error (_tmp71_, FALSE, FALSE);
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp71_);
#line 193 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp69_);
#line 194 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = NULL;
#line 194 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 194 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 194 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 967 "SystemUser.c"
	}
#line 197 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = user;
#line 197 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 197 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 975 "SystemUser.c"
}


static SystemUser*
system_user_parse_line_shadow (const gchar* line,
                               GeeHashMap* list)
{
	SystemUser* result = NULL;
	gboolean _tmp0_ = FALSE;
	SystemUser* user = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (line == NULL) {
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 1001 "SystemUser.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = strlen (line);
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = _tmp1_;
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = _tmp2_ == 0;
#line 1011 "SystemUser.c"
	}
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp0_) {
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = NULL;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 1019 "SystemUser.c"
	}
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	user = NULL;
#line 210 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 210 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields = _tmp4_;
#line 210 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 210 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_fields_size_ = fields_length1;
#line 212 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = fields;
#line 212 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5__length1 = fields_length1;
#line 212 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp5__length1 == 9) {
#line 1037 "SystemUser.c"
		gchar* user_name = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 213 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6_ = fields;
#line 213 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6__length1 = fields_length1;
#line 213 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp7_ = _tmp6_[0];
#line 213 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 213 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		user_name = _tmp8_;
#line 214 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp9_ = user_name;
#line 214 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		if (gee_abstract_map_has_key ((GeeAbstractMap*) list, _tmp9_)) {
#line 1058 "SystemUser.c"
			const gchar* _tmp10_;
			gpointer _tmp11_;
			SystemUser* _tmp12_;
			gchar* _tmp13_;
			SystemUser* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			SystemUser* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			SystemUser* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			SystemUser* _tmp26_;
			gchar** _tmp27_;
			gint _tmp27__length1;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			SystemUser* _tmp30_;
			gchar** _tmp31_;
			gint _tmp31__length1;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			SystemUser* _tmp34_;
			gchar** _tmp35_;
			gint _tmp35__length1;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			SystemUser* _tmp38_;
			gchar** _tmp39_;
			gint _tmp39__length1;
			const gchar* _tmp40_;
			gchar* _tmp41_;
			SystemUser* _tmp42_;
			gchar** _tmp43_;
			gint _tmp43__length1;
			const gchar* _tmp44_;
			gchar* _tmp45_;
#line 215 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp10_ = user_name;
#line 215 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) list, _tmp10_);
#line 215 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 215 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			user = (SystemUser*) _tmp11_;
#line 216 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp12_ = user;
#line 216 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp13_ = g_strdup (line);
#line 216 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp12_->shadow_line);
#line 216 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp12_->shadow_line = _tmp13_;
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp14_ = user;
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp15_ = fields;
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp15__length1 = fields_length1;
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp16_ = _tmp15_[1];
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp17_ = string_strip (_tmp16_);
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp14_->pwd_hash);
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp14_->pwd_hash = _tmp17_;
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp18_ = user;
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp19_ = fields;
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp19__length1 = fields_length1;
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp20_ = _tmp19_[2];
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp21_ = string_strip (_tmp20_);
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp18_->pwd_last_changed);
#line 218 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp18_->pwd_last_changed = _tmp21_;
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp22_ = user;
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp23_ = fields;
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp23__length1 = fields_length1;
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp24_ = _tmp23_[3];
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp22_->pwd_age_min);
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp22_->pwd_age_min = _tmp25_;
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp26_ = user;
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp27_ = fields;
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp27__length1 = fields_length1;
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp28_ = _tmp27_[4];
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp29_ = string_strip (_tmp28_);
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp26_->pwd_age_max);
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp26_->pwd_age_max = _tmp29_;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp30_ = user;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp31_ = fields;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp31__length1 = fields_length1;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp32_ = _tmp31_[5];
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp33_ = string_strip (_tmp32_);
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp30_->pwd_warning_period);
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp30_->pwd_warning_period = _tmp33_;
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp34_ = user;
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp35_ = fields;
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp35__length1 = fields_length1;
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp36_ = _tmp35_[6];
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp37_ = string_strip (_tmp36_);
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp34_->pwd_inactivity_period);
#line 222 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp34_->pwd_inactivity_period = _tmp37_;
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp38_ = user;
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp39_ = fields;
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp39__length1 = fields_length1;
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp40_ = _tmp39_[7];
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp41_ = string_strip (_tmp40_);
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp38_->pwd_expiraton_date);
#line 223 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp38_->pwd_expiraton_date = _tmp41_;
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp42_ = user;
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp43_ = fields;
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp43__length1 = fields_length1;
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp44_ = _tmp43_[8];
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp45_ = string_strip (_tmp44_);
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp42_->reserved_field);
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp42_->reserved_field = _tmp45_;
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			result = user;
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (user_name);
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			return result;
#line 1239 "SystemUser.c"
		} else {
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp46_ = user_name;
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp47_ = g_strdup_printf (": %s", _tmp46_);
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp48_ = _tmp47_;
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp49_ = g_strconcat ("user in file 'shadow' does not exist in file 'passwd'", _tmp48_, NULL);
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp50_ = _tmp49_;
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			tee_jee_logging_log_error (_tmp50_, FALSE, FALSE);
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp50_);
#line 228 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (_tmp48_);
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			result = NULL;
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_free0 (user_name);
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			return result;
#line 1272 "SystemUser.c"
		}
#line 212 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (user_name);
#line 1276 "SystemUser.c"
	} else {
		gchar** _tmp51_;
		gint _tmp51__length1;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp51_ = fields;
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp51__length1 = fields_length1;
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp52_ = g_strdup_printf (": %d", _tmp51__length1);
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp53_ = _tmp52_;
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp54_ = g_strconcat ("'shadow' file contains a record with non-standard fields", _tmp53_, NULL);
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp55_ = _tmp54_;
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		tee_jee_logging_log_error (_tmp55_, FALSE, FALSE);
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp55_);
#line 233 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (_tmp53_);
#line 234 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		result = NULL;
#line 234 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 234 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 234 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		return result;
#line 1310 "SystemUser.c"
	}
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_object_unref0 (user);
#line 1316 "SystemUser.c"
}


gint
system_user_add_user (const gchar* user_name,
                      gboolean system_account)
{
	gint result = 0;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint status = 0;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
	gint _tmp7_;
#line 238 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (user_name != NULL, 0);
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (system_account) {
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = " --system";
#line 1343 "SystemUser.c"
	} else {
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = "";
#line 1347 "SystemUser.c"
	}
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = g_strdup_printf ("adduser%s --gecos '' --disabled-login %s", _tmp0_, user_name);
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	cmd = _tmp1_;
#line 241 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = cmd;
#line 241 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	tee_jee_logging_log_debug (_tmp2_);
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = cmd;
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = tee_jee_process_helper_exec_sync (_tmp3_, &_tmp4_, &_tmp5_);
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (std_out);
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	std_out = _tmp4_;
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (std_err);
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	std_err = _tmp5_;
#line 242 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	status = _tmp6_;
#line 243 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp7_ = status;
#line 243 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp7_ != 0) {
#line 1375 "SystemUser.c"
		const gchar* _tmp8_;
#line 244 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp8_ = std_err;
#line 244 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 1381 "SystemUser.c"
	} else {
	}
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = status;
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (cmd);
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (std_err);
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (std_out);
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 1394 "SystemUser.c"
}


gint
system_user_add (SystemUser* self)
{
	gint result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 252 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 253 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = self->name;
#line 253 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = system_user_get_is_system (self);
#line 253 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = _tmp1_;
#line 253 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = system_user_add_user (_tmp0_, _tmp2_);
#line 253 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 1417 "SystemUser.c"
}


void
system_user_check_encrypted_dirs (SystemUser* self)
{
	gchar* ecryptfs_mount_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
#line 256 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_if_fail (self != NULL);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = self->name;
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = g_strdup_printf ("/home/.ecryptfs/%s/.ecryptfs/Private.mnt", _tmp0_);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	ecryptfs_mount_file = _tmp1_;
#line 262 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = ecryptfs_mount_file;
#line 262 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (tee_jee_file_system_file_exists (_tmp2_)) {
#line 1443 "SystemUser.c"
		gchar* txt = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
#line 264 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp3_ = ecryptfs_mount_file;
#line 264 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp4_ = tee_jee_file_system_file_read (_tmp3_);
#line 264 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp4_;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp5_ = txt;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 1460 "SystemUser.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection = _tmp7_;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection_length1 = _vala_array_length (_tmp6_);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			for (line_it = 0; line_it < _vala_array_length (_tmp6_); line_it = line_it + 1) {
#line 1472 "SystemUser.c"
				gchar* _tmp8_;
				gchar* line = NULL;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp8_ = g_strdup (line_collection[line_it]);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				line = _tmp8_;
#line 1479 "SystemUser.c"
				{
					gchar* path = NULL;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					const gchar* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					GeeArrayList* _tmp16_;
					const gchar* _tmp17_;
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp9_ = line;
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp10_ = string_strip (_tmp9_);
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					path = _tmp10_;
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp11_ = path;
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp12_ = strlen (_tmp11_);
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp13_ = _tmp12_;
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					if (_tmp13_ == 0) {
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_g_free0 (path);
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_g_free0 (line);
#line 270 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						continue;
#line 1511 "SystemUser.c"
					}
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp14_ = path;
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp15_ = self->home_path;
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 273 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						self->has_encrypted_home = TRUE;
#line 1521 "SystemUser.c"
					}
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp16_ = self->encrypted_dirs;
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp17_ = path;
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (path);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 1533 "SystemUser.c"
				}
			}
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1538 "SystemUser.c"
		}
#line 262 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 1542 "SystemUser.c"
	}
#line 282 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp18_ = self->home_path;
#line 282 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp19_ = g_strdup_printf ("%s/.ecryptfs/Private.mnt", _tmp18_);
#line 282 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (ecryptfs_mount_file);
#line 282 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	ecryptfs_mount_file = _tmp19_;
#line 284 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp20_ = ecryptfs_mount_file;
#line 284 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (tee_jee_file_system_file_exists (_tmp20_)) {
#line 1556 "SystemUser.c"
		gchar* txt = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
#line 286 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp21_ = ecryptfs_mount_file;
#line 286 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp22_ = tee_jee_file_system_file_read (_tmp21_);
#line 286 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		txt = _tmp22_;
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp23_ = txt;
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "\n", 0);
#line 1573 "SystemUser.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection = _tmp25_;
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection_length1 = _vala_array_length (_tmp24_);
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			for (line_it = 0; line_it < _vala_array_length (_tmp24_); line_it = line_it + 1) {
#line 1585 "SystemUser.c"
				gchar* _tmp26_;
				gchar* line = NULL;
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp26_ = g_strdup (line_collection[line_it]);
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				line = _tmp26_;
#line 1592 "SystemUser.c"
				{
					gchar* path = NULL;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					GeeArrayList* _tmp36_;
					const gchar* _tmp37_;
#line 290 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp27_ = line;
#line 290 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp28_ = string_strip (_tmp27_);
#line 290 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					path = _tmp28_;
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp29_ = path;
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp30_ = strlen (_tmp29_);
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp31_ = _tmp30_;
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					if (_tmp31_ == 0) {
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_g_free0 (path);
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_g_free0 (line);
#line 292 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						continue;
#line 1624 "SystemUser.c"
					}
#line 294 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp32_ = path;
#line 294 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp33_ = self->home_path;
#line 294 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					if (g_strcmp0 (_tmp32_, _tmp33_) != 0) {
#line 1632 "SystemUser.c"
						GeeArrayList* _tmp34_;
						const gchar* _tmp35_;
#line 295 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						self->has_encrypted_private_dirs = TRUE;
#line 296 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_tmp34_ = self->encrypted_private_dirs;
#line 296 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						_tmp35_ = path;
#line 296 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 1643 "SystemUser.c"
					}
#line 299 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp36_ = self->encrypted_dirs;
#line 299 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp37_ = path;
#line 299 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (path);
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 1655 "SystemUser.c"
				}
			}
#line 288 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1660 "SystemUser.c"
		}
#line 284 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_free0 (txt);
#line 1664 "SystemUser.c"
	}
#line 256 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (ecryptfs_mount_file);
#line 1668 "SystemUser.c"
}


gboolean
system_user_update_passwd_file (SystemUser* self)
{
	gboolean result = FALSE;
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("/etc/passwd");
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	file_path = _tmp0_;
#line 319 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = file_path;
#line 319 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 319 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp2_;
#line 321 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = g_strdup ("");
#line 321 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt_new = _tmp3_;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = txt;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 1713 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = _tmp6_;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp5_); line_it = line_it + 1) {
#line 1725 "SystemUser.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line = _tmp7_;
#line 1732 "SystemUser.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp8_ = line;
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp10_ = _tmp9_;
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp11_ = strlen (_tmp10_);
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp12_ = _tmp11_;
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp13_ = _tmp12_ == 0;
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (_tmp10_);
#line 323 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp13_) {
#line 324 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 324 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					continue;
#line 1775 "SystemUser.c"
				}
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp14_ = line;
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts = _tmp16_;
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_parts_size_ = parts_length1;
#line 329 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp17_ = parts;
#line 329 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp17__length1 = parts_length1;
#line 329 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp17__length1 != 7) {
#line 1793 "SystemUser.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp18_ = parts;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp18__length1 = parts_length1;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp20_ = _tmp19_;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp21_ = g_strconcat ("'passwd' file contains a record with non-standard fields", _tmp20_, NULL);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp22_ = _tmp21_;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp22_);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp20_);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					result = FALSE;
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (file_path);
#line 331 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					return result;
#line 1834 "SystemUser.c"
				}
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp23_ = parts;
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp23__length1 = parts_length1;
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp24_ = _tmp23_[0];
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp26_ = _tmp25_;
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp27_ = self->name;
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (_tmp26_);
#line 334 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp28_) {
#line 1854 "SystemUser.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp29_ = txt_new;
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp30_ = system_user_get_passwd_line (self);
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp31_ = _tmp30_;
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp33_ = _tmp32_;
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					txt_new = _tmp34_;
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp33_);
#line 335 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp31_);
#line 1881 "SystemUser.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp35_ = txt_new;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp36_ = line;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp38_ = _tmp37_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					txt_new = _tmp39_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp38_);
#line 1904 "SystemUser.c"
				}
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (line);
#line 1910 "SystemUser.c"
			}
		}
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1915 "SystemUser.c"
	}
#line 342 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp40_ = file_path;
#line 342 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp41_ = txt_new;
#line 342 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp42_ = self->name;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp44_ = _tmp43_;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp45_ = g_strconcat ("Updated user settings in /etc/passwd", _tmp44_, NULL);
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp46_ = _tmp45_;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp46_);
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp44_);
#line 346 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = TRUE;
#line 346 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt_new);
#line 346 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 346 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (file_path);
#line 346 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 1949 "SystemUser.c"
}


gchar*
system_user_get_passwd_line (SystemUser* self)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
#line 349 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 350 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 350 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp0_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = txt;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = self->name;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = _tmp3_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp5_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp4_);
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = txt;
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp7_ = self->password;
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp9_ = _tmp8_;
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp10_;
#line 352 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp9_);
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp11_ = txt;
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp12_ = self->uid;
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp13_ = g_strdup_printf (":%d", _tmp12_);
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp14_ = _tmp13_;
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp15_;
#line 353 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp14_);
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp16_ = txt;
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp17_ = self->gid;
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp18_ = g_strdup_printf (":%d", _tmp17_);
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp19_ = _tmp18_;
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp20_;
#line 354 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp19_);
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp21_ = txt;
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp22_ = self->user_info;
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp23_ = g_strdup_printf (":%s", _tmp22_);
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp24_ = _tmp23_;
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp25_;
#line 355 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp24_);
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp26_ = txt;
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp27_ = self->home_path;
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp28_ = g_strdup_printf (":%s", _tmp27_);
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp29_ = _tmp28_;
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp30_ = g_strconcat (_tmp26_, _tmp29_, NULL);
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp30_;
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp29_);
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp31_ = txt;
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp32_ = self->shell_path;
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp33_ = g_strdup_printf (":%s", _tmp32_);
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp34_ = _tmp33_;
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp35_ = g_strconcat (_tmp31_, _tmp34_, NULL);
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp35_;
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp34_);
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = txt;
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2116 "SystemUser.c"
}


gboolean
system_user_update_shadow_file (SystemUser* self)
{
	gboolean result = FALSE;
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 362 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("/etc/shadow");
#line 362 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	file_path = _tmp0_;
#line 363 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = file_path;
#line 363 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 363 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp2_;
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = g_strdup ("");
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt_new = _tmp3_;
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = txt;
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 2161 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = _tmp6_;
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp5_); line_it = line_it + 1) {
#line 2173 "SystemUser.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			line = _tmp7_;
#line 2180 "SystemUser.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp8_ = line;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp10_ = _tmp9_;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp11_ = strlen (_tmp10_);
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp12_ = _tmp11_;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp13_ = _tmp12_ == 0;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (_tmp10_);
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp13_) {
#line 368 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 368 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					continue;
#line 2223 "SystemUser.c"
				}
#line 371 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp14_ = line;
#line 371 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 371 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts = _tmp16_;
#line 371 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 371 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_parts_size_ = parts_length1;
#line 373 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp17_ = parts;
#line 373 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp17__length1 = parts_length1;
#line 373 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp17__length1 != 9) {
#line 2241 "SystemUser.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp18_ = parts;
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp18__length1 = parts_length1;
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp20_ = _tmp19_;
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp21_ = g_strconcat ("'shadow' file contains a record with non-standard fields", _tmp20_, NULL);
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp22_ = _tmp21_;
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp22_);
#line 374 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp20_);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					result = FALSE;
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (line);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (file_path);
#line 375 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					return result;
#line 2282 "SystemUser.c"
				}
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp23_ = parts;
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp23__length1 = parts_length1;
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp24_ = _tmp23_[0];
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp26_ = _tmp25_;
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp27_ = self->name;
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (_tmp26_);
#line 378 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				if (_tmp28_) {
#line 2302 "SystemUser.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp29_ = txt_new;
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp30_ = system_user_get_shadow_line (self);
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp31_ = _tmp30_;
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp33_ = _tmp32_;
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					txt_new = _tmp34_;
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp33_);
#line 379 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp31_);
#line 2329 "SystemUser.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp35_ = txt_new;
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp36_ = line;
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp38_ = _tmp37_;
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (txt_new);
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					txt_new = _tmp39_;
#line 382 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
					_g_free0 (_tmp38_);
#line 2352 "SystemUser.c"
				}
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				_g_free0 (line);
#line 2358 "SystemUser.c"
			}
		}
#line 366 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2363 "SystemUser.c"
	}
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp40_ = file_path;
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp41_ = txt_new;
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp42_ = self->name;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp44_ = _tmp43_;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp45_ = g_strconcat ("Updated user settings in /etc/shadow", _tmp44_, NULL);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp46_ = _tmp45_;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp46_);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp44_);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = TRUE;
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt_new);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (file_path);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2397 "SystemUser.c"
}


gchar*
system_user_get_shadow_line (SystemUser* self)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
#line 393 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp0_;
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = txt;
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = self->name;
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = _tmp3_;
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp5_;
#line 395 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp4_);
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = txt;
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp7_ = self->pwd_hash;
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp9_ = _tmp8_;
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp10_;
#line 396 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp9_);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp11_ = txt;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp12_ = self->pwd_last_changed;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp13_ = g_strdup_printf (":%s", _tmp12_);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp14_ = _tmp13_;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp15_;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp14_);
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp16_ = txt;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp17_ = self->pwd_age_min;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp18_ = g_strdup_printf (":%s", _tmp17_);
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp19_ = _tmp18_;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp20_;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp19_);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp21_ = txt;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp22_ = self->pwd_age_max;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp23_ = g_strdup_printf (":%s", _tmp22_);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp24_ = _tmp23_;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp25_;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp24_);
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp26_ = txt;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp27_ = self->pwd_warning_period;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp28_ = g_strdup_printf (":%s", _tmp27_);
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp29_ = _tmp28_;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp30_ = g_strconcat (_tmp26_, _tmp29_, NULL);
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp30_;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp29_);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp31_ = txt;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp32_ = self->pwd_inactivity_period;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp33_ = g_strdup_printf (":%s", _tmp32_);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp34_ = _tmp33_;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp35_ = g_strconcat (_tmp31_, _tmp34_, NULL);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp35_;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp34_);
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp36_ = txt;
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp37_ = self->pwd_expiraton_date;
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp38_ = g_strdup_printf (":%s", _tmp37_);
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp39_ = _tmp38_;
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp40_;
#line 402 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp39_);
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp41_ = txt;
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp42_ = self->reserved_field;
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp43_ = g_strdup_printf (":%s", _tmp42_);
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp44_ = _tmp43_;
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp45_ = g_strconcat (_tmp41_, _tmp44_, NULL);
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (txt);
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	txt = _tmp45_;
#line 403 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (_tmp44_);
#line 404 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = txt;
#line 404 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2606 "SystemUser.c"
}


static gint
_system_user_all_users_sorted___lambda11_ (SystemUser* a,
                                           SystemUser* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strcmp0;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = a->name;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = b->name;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2632 "SystemUser.c"
}


static gint
__system_user_all_users_sorted___lambda11__gcompare_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self)
{
	gint result;
	result = _system_user_all_users_sorted___lambda11_ ((SystemUser*) a, (SystemUser*) b);
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2645 "SystemUser.c"
}


GeeArrayList*
system_user_get_all_users_sorted (void)
{
	GeeArrayList* result;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp12_;
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = gee_array_list_new (TYPE_SYSTEM_USER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	list = _tmp0_;
#line 2660 "SystemUser.c"
	{
		GeeIterator* _user_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = system_user_all_users;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp3_ = _tmp2_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp4_ = _tmp3_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6_ = _tmp5_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (_tmp4_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_user_it = _tmp6_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		while (TRUE) {
#line 2687 "SystemUser.c"
			GeeIterator* _tmp7_;
			SystemUser* user = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeArrayList* _tmp10_;
			SystemUser* _tmp11_;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp7_ = _user_it;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
				break;
#line 2700 "SystemUser.c"
			}
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp8_ = _user_it;
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			user = (SystemUser*) _tmp9_;
#line 82 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp10_ = list;
#line 82 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_tmp11_ = user;
#line 82 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 2716 "SystemUser.c"
		}
#line 81 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_g_object_unref0 (_user_it);
#line 2720 "SystemUser.c"
	}
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp12_ = list;
#line 84 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	gee_list_sort ((GeeList*) _tmp12_, __system_user_all_users_sorted___lambda11__gcompare_data_func, NULL, NULL);
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = list;
#line 85 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2730 "SystemUser.c"
}


gboolean
system_user_get_is_installed (SystemUser* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = system_user_all_users;
#line 91 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = self->name;
#line 91 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 91 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2750 "SystemUser.c"
}


gboolean
system_user_get_is_system (SystemUser* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
#line 305 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = self->uid;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp3_ != 0) {
#line 2768 "SystemUser.c"
		gint _tmp4_;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp4_ = self->uid;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = _tmp4_ < 1000;
#line 2774 "SystemUser.c"
	} else {
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp2_ = FALSE;
#line 2778 "SystemUser.c"
	}
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp2_) {
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = TRUE;
#line 2784 "SystemUser.c"
	} else {
		gint _tmp5_;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp5_ = self->uid;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp1_ = _tmp5_ == 65534;
#line 2791 "SystemUser.c"
	}
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	if (_tmp1_) {
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 2797 "SystemUser.c"
	} else {
		const gchar* _tmp6_;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp6_ = self->name;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, "PinguyBuilder") == 0;
#line 2804 "SystemUser.c"
	}
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = _tmp0_;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2810 "SystemUser.c"
}


gchar*
system_user_get_group_names (SystemUser* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 311 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 312 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 312 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	result = _tmp0_;
#line 312 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	return result;
#line 2827 "SystemUser.c"
}


static void
system_user_class_init (SystemUserClass * klass)
{
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	system_user_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_system_user_get_property;
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	G_OBJECT_CLASS (klass)->finalize = system_user_finalize;
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_IS_INSTALLED_PROPERTY, system_user_properties[SYSTEM_USER_IS_INSTALLED_PROPERTY] = g_param_spec_boolean ("is-installed", "is-installed", "is-installed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_IS_SYSTEM_PROPERTY, system_user_properties[SYSTEM_USER_IS_SYSTEM_PROPERTY] = g_param_spec_boolean ("is-system", "is-system", "is-system", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_GROUP_NAMES_PROPERTY, system_user_properties[SYSTEM_USER_GROUP_NAMES_PROPERTY] = g_param_spec_string ("group-names", "group-names", "group-names", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2846 "SystemUser.c"
}


static void
system_user_instance_init (SystemUser * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
#line 31 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 31 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->name = _tmp0_;
#line 32 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp1_ = g_strdup ("");
#line 32 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->password = _tmp1_;
#line 33 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->uid = -1;
#line 34 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->gid = -1;
#line 35 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp2_ = g_strdup ("");
#line 35 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->user_info = _tmp2_;
#line 36 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp3_ = g_strdup ("");
#line 36 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->home_path = _tmp3_;
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp4_ = g_strdup ("");
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->shell_path = _tmp4_;
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp5_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->full_name = _tmp5_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp6_ = g_strdup ("");
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->room_num = _tmp6_;
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp7_ = g_strdup ("");
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->phone_work = _tmp7_;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp8_ = g_strdup ("");
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->phone_home = _tmp8_;
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp9_ = g_strdup ("");
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->other_info = _tmp9_;
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp10_ = g_strdup ("");
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->shadow_line = _tmp10_;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp11_ = g_strdup ("");
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_hash = _tmp11_;
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp12_ = g_strdup ("");
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_last_changed = _tmp12_;
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp13_ = g_strdup ("");
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_age_min = _tmp13_;
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp14_ = g_strdup ("");
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_age_max = _tmp14_;
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp15_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_warning_period = _tmp15_;
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp16_ = g_strdup ("");
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_inactivity_period = _tmp16_;
#line 53 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp17_ = g_strdup ("");
#line 53 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->pwd_expiraton_date = _tmp17_;
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp18_ = g_strdup ("");
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->reserved_field = _tmp18_;
#line 56 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->has_encrypted_home = FALSE;
#line 57 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->has_encrypted_private_dirs = FALSE;
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp19_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->encrypted_dirs = _tmp19_;
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->encrypted_private_dirs = _tmp20_;
#line 61 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self->is_selected = FALSE;
#line 2968 "SystemUser.c"
}


static void
system_user_finalize (GObject * obj)
{
	SystemUser * self;
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SYSTEM_USER, SystemUser);
#line 31 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->name);
#line 32 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->password);
#line 35 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->user_info);
#line 36 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->home_path);
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->shell_path);
#line 39 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->full_name);
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->room_num);
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->phone_work);
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->phone_home);
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->other_info);
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->shadow_line);
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_hash);
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_last_changed);
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_age_min);
#line 50 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_age_max);
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_warning_period);
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_inactivity_period);
#line 53 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->pwd_expiraton_date);
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_free0 (self->reserved_field);
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_object_unref0 (self->encrypted_dirs);
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	_g_object_unref0 (self->encrypted_private_dirs);
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	G_OBJECT_CLASS (system_user_parent_class)->finalize (obj);
#line 3022 "SystemUser.c"
}


GType
system_user_get_type (void)
{
	static volatile gsize system_user_type_id__volatile = 0;
	if (g_once_init_enter (&system_user_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SystemUserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) system_user_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SystemUser), 0, (GInstanceInitFunc) system_user_instance_init, NULL };
		GType system_user_type_id;
		system_user_type_id = g_type_register_static (G_TYPE_OBJECT, "SystemUser", &g_define_type_info, 0);
		g_once_init_leave (&system_user_type_id__volatile, system_user_type_id);
	}
	return system_user_type_id__volatile;
}


static void
_vala_system_user_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SystemUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SYSTEM_USER, SystemUser);
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		case SYSTEM_USER_IS_INSTALLED_PROPERTY:
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		g_value_set_boolean (value, system_user_get_is_installed (self));
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		break;
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		case SYSTEM_USER_IS_SYSTEM_PROPERTY:
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		g_value_set_boolean (value, system_user_get_is_system (self));
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		break;
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		case SYSTEM_USER_GROUP_NAMES_PROPERTY:
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		g_value_take_string (value, system_user_get_group_names (self));
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		break;
#line 3068 "SystemUser.c"
		default:
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/SystemUser.vala"
		break;
#line 3074 "SystemUser.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



