/* TeeJee.System.c generated by valac 0.40.6, the Vala compiler
 * generated from TeeJee.System.vala, do not modify */

/*
 * TeeJee.System.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <locale.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))



gboolean tee_jee_system_user_is_admin (void);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gchar* tee_jee_system_get_user_login (void);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gint tee_jee_system_get_user_id (void);
gint tee_jee_system_get_user_id_from_username (const gchar* username);
gint tee_jee_system_get_user_id_effective (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_system_get_username (void);
gchar* tee_jee_system_get_username_from_uid (gint user_id);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gchar* tee_jee_system_get_app_path (void);
gchar* tee_jee_system_get_app_dir (void);
gdouble tee_jee_system_get_system_uptime_seconds (void);
gchar* tee_jee_system_get_desktop_name (void);
gint tee_jee_process_helper_get_pid_by_name (const gchar* name);
GeeArrayList* tee_jee_system_list_dir_names (const gchar* path);
static gint __lambda19_ (const gchar* a,
                  const gchar* b);
static gint ___lambda19__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gint tee_jee_system_get_display_width (void);
gint tee_jee_system_get_display_height (void);
gboolean tee_jee_system_check_internet_connectivity (void);
gboolean tee_jee_system_check_internet_connectivity_test1 (void);
gboolean tee_jee_system_check_internet_connectivity_test2 (void);
gboolean tee_jee_system_shutdown (void);
gboolean tee_jee_system_command_exists (const gchar* command);
gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool);
gboolean tee_jee_system_xdg_open (const gchar* file,
                                  const gchar* user);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
void tee_jee_logging_log_debug (const gchar* message);
gint tee_jee_process_helper_exec_script_async (const gchar* script);
gboolean tee_jee_system_exo_open_folder (const gchar* dir_path,
                                         gboolean xdg_open_try_first);
gboolean tee_jee_system_exo_open_textfile (const gchar* txt_file);
gboolean tee_jee_system_exo_open_url (const gchar* url);
gboolean tee_jee_system_using_efi_boot (void);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_system_open_terminal_window (const gchar* terminal_emulator,
                                          const gchar* working_dir,
                                          const gchar* script_file_to_execute,
                                          gboolean run_as_admin);
GTimer* tee_jee_system_timer_start (void);
gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
void tee_jee_system_sleep (gint milliseconds);
gchar* tee_jee_system_timer_elapsed_string (GTimer* timer,
                                            gboolean stop);
void tee_jee_system_timer_elapsed_print (GTimer* timer,
                                         gboolean stop);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
void tee_jee_system_set_numeric_locale (const gchar* type);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gboolean
tee_jee_system_user_is_admin (void)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
	{
		gchar** argv = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gint argv_length1;
		gint _argv_size_;
		GPid procId = 0;
		gchar** _tmp3_;
		gint _tmp3__length1;
		GPid _tmp4_ = 0;
		GPid _tmp5_;
		GPid _tmp6_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = g_strdup ("sleep");
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("10");
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_[0] = _tmp0_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_[1] = _tmp1_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv = _tmp2_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv_length1 = 2;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_argv_size_ = argv_length1;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = argv;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3__length1 = argv_length1;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_spawn_async (NULL, _tmp3_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, &_inner_error_);
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		procId = _tmp4_;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 172 "TeeJee.System.c"
			goto __catch94_g_error;
		}
#line 45 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = procId;
#line 45 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		setpriority (PRIO_PROCESS, (gint) _tmp5_, -5);
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = procId;
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (getpriority (PRIO_PROCESS, (gint) _tmp6_) == -5) {
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			result = TRUE;
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			return result;
#line 189 "TeeJee.System.c"
		} else {
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			result = FALSE;
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			return result;
#line 197 "TeeJee.System.c"
		}
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 201 "TeeJee.System.c"
	}
	goto __finally94;
	__catch94_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = e;
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = _tmp7_->message;
#line 54 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 55 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = FALSE;
#line 55 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 55 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 225 "TeeJee.System.c"
	}
	__finally94:
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error_);
#line 38 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return _tmp9_;
#line 234 "TeeJee.System.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 259 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_user_login (void)
{
	gchar* result = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* user_name = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("echo ${SUDO_USER:-$(whoami)}");
#line 66 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = tee_jee_process_helper_exec_script_sync (_tmp1_, &_tmp2_, &_tmp3_, FALSE, FALSE, TRUE, FALSE);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_out = _tmp2_;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_err = _tmp3_;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	ret_val = _tmp4_;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = std_out;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp6_ == NULL) {
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = TRUE;
#line 303 "TeeJee.System.c"
	} else {
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = std_out;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = strlen (_tmp7_);
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_;
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp9_ == 0;
#line 316 "TeeJee.System.c"
	}
#line 73 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp5_) {
#line 320 "TeeJee.System.c"
		gchar* _tmp10_;
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup ("root");
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (user_name);
#line 74 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		user_name = _tmp10_;
#line 328 "TeeJee.System.c"
	} else {
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp11_ = std_out;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp12_ = string_strip (_tmp11_);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (user_name);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		user_name = _tmp12_;
#line 340 "TeeJee.System.c"
	}
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = user_name;
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 80 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 352 "TeeJee.System.c"
}


gint
tee_jee_system_get_user_id (void)
{
	gint result = 0;
	gchar* pkexec_uid = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* sudo_user = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_getenv ("PKEXEC_UID");
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 90 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pkexec_uid = _tmp1_;
#line 92 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = pkexec_uid;
#line 92 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 378 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = pkexec_uid;
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = atoi (_tmp3_);
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (pkexec_uid);
#line 93 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 388 "TeeJee.System.c"
	}
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = g_getenv ("SUDO_USER");
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 96 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	sudo_user = _tmp5_;
#line 98 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = sudo_user;
#line 98 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp6_ != NULL) {
#line 400 "TeeJee.System.c"
		const gchar* _tmp7_;
#line 99 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = sudo_user;
#line 99 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = tee_jee_system_get_user_id_from_username (_tmp7_);
#line 99 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (sudo_user);
#line 99 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (pkexec_uid);
#line 99 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 412 "TeeJee.System.c"
	}
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = tee_jee_system_get_user_id_effective ();
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (sudo_user);
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (pkexec_uid);
#line 102 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 422 "TeeJee.System.c"
}


gint
tee_jee_system_get_user_id_effective (void)
{
	gint result = 0;
	gint uid = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 109 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	uid = -1;
#line 110 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("id -u");
#line 110 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_out = _tmp2_;
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 112 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_err = _tmp3_;
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp5_ = std_out;
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp5_ != NULL) {
#line 462 "TeeJee.System.c"
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = std_out;
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = strlen (_tmp6_);
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = _tmp7_;
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = _tmp8_ > 0;
#line 474 "TeeJee.System.c"
	} else {
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = FALSE;
#line 478 "TeeJee.System.c"
	}
#line 113 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp4_) {
#line 482 "TeeJee.System.c"
		const gchar* _tmp9_;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = std_out;
#line 114 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		uid = atoi (_tmp9_);
#line 488 "TeeJee.System.c"
	}
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = uid;
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 117 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 500 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_username (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 124 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_system_get_username_from_uid (tee_jee_system_get_user_id ());
#line 124 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp0_;
#line 124 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 515 "TeeJee.System.c"
}


gint
tee_jee_system_get_user_id_from_username (const gchar* username)
{
	gint result = 0;
	gint user_id = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 127 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (username != NULL, 0);
#line 129 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	user_id = -1;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_file_system_file_read ("/etc/passwd");
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = _tmp0_;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "\n", 0);
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = _tmp3_;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (_tmp1_);
#line 546 "TeeJee.System.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection = _tmp4_;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection_length1 = _tmp4__length1;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		for (line_it = 0; line_it < _tmp4__length1; line_it = line_it + 1) {
#line 558 "TeeJee.System.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			line = _tmp5_;
#line 565 "TeeJee.System.c"
			{
				gchar** arr = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint arr_length1;
				gint _arr_size_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
#line 132 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp6_ = line;
#line 132 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
#line 132 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr = _tmp8_;
#line 132 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr_length1 = _vala_array_length (_tmp7_);
#line 132 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_arr_size_ = arr_length1;
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp9_ = arr;
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp9__length1 = arr_length1;
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp9__length1 < 3) {
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 133 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					continue;
#line 600 "TeeJee.System.c"
				}
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp10_ = arr;
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp10__length1 = arr_length1;
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp11_ = _tmp10_[0];
#line 134 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (g_strcmp0 (_tmp11_, username) == 0) {
#line 610 "TeeJee.System.c"
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp12_ = arr;
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp12__length1 = arr_length1;
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp13_ = _tmp12_[2];
#line 135 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					user_id = atoi (_tmp13_);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 136 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					break;
#line 628 "TeeJee.System.c"
				}
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_free0 (line);
#line 634 "TeeJee.System.c"
			}
		}
#line 131 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 639 "TeeJee.System.c"
	}
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = user_id;
#line 140 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 645 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_username_from_uid (gint user_id)
{
	gchar* result = NULL;
	gchar* username = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 145 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	username = _tmp0_;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = tee_jee_file_system_file_read ("/etc/passwd");
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = _tmp1_;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp5_ = _tmp4_;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp5__length1 = _vala_array_length (_tmp3_);
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (_tmp2_);
#line 677 "TeeJee.System.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection = _tmp5_;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection_length1 = _tmp5__length1;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		for (line_it = 0; line_it < _tmp5__length1; line_it = line_it + 1) {
#line 689 "TeeJee.System.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			line = _tmp6_;
#line 696 "TeeJee.System.c"
			{
				gchar** arr = NULL;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint arr_length1;
				gint _arr_size_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp7_ = line;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ":", 0);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr = _tmp9_;
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr_length1 = _vala_array_length (_tmp8_);
#line 148 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_arr_size_ = arr_length1;
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp10_ = arr;
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp10__length1 = arr_length1;
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp10__length1 < 3) {
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 149 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					continue;
#line 731 "TeeJee.System.c"
				}
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp11_ = arr;
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp11__length1 = arr_length1;
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp12_ = _tmp11_[2];
#line 150 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (atoi (_tmp12_) == user_id) {
#line 741 "TeeJee.System.c"
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp13_ = arr;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp13__length1 = arr_length1;
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp14_ = _tmp13_[0];
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (username);
#line 151 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					username = _tmp15_;
#line 152 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 152 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 152 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					break;
#line 764 "TeeJee.System.c"
				}
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_free0 (line);
#line 770 "TeeJee.System.c"
			}
		}
#line 147 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 775 "TeeJee.System.c"
	}
#line 156 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = username;
#line 156 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 781 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_app_path (void)
{
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_file_read_link ("/proc/self/exe", &_inner_error_);
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = _tmp1_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 800 "TeeJee.System.c"
			goto __catch95_g_error;
		}
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = _tmp0_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = NULL;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp2_;
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp0_);
#line 167 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 813 "TeeJee.System.c"
	}
	goto __finally95;
	__catch95_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = e;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = _tmp3_->message;
#line 170 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("");
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp5_;
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 171 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 840 "TeeJee.System.c"
	}
	__finally95:
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error_);
#line 166 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return NULL;
#line 849 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_app_dir (void)
{
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_file_read_link ("/proc/self/exe", &_inner_error_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = _tmp1_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 873 "TeeJee.System.c"
			goto __catch96_g_error;
		}
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = g_file_new_for_path (_tmp0_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = _tmp2_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = g_file_get_parent (_tmp3_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (_tmp5_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (_tmp3_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp7_;
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp0_);
#line 180 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 898 "TeeJee.System.c"
	}
	goto __finally96;
	__catch96_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 179 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 179 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = e;
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_->message;
#line 183 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup ("");
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp10_;
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 184 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 925 "TeeJee.System.c"
	}
	__finally96:
#line 179 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 179 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error_);
#line 179 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return NULL;
#line 934 "TeeJee.System.c"
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 889 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 890 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_ascii_strtod (str, NULL);
#line 890 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 890 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 951 "TeeJee.System.c"
}


gdouble
tee_jee_system_get_system_uptime_seconds (void)
{
	gdouble result = 0.0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gdouble _tmp15_ = 0.0;
	GError * _inner_error_ = NULL;
#line 195 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 195 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 970 "TeeJee.System.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gchar* uptime = NULL;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gdouble secs = 0.0;
		const gchar* _tmp12_;
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("cat /proc/uptime");
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 201 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		cmd = _tmp1_;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = cmd;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		std_out = _tmp3_;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		std_err = _tmp4_;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		ret_val = _tmp5_;
#line 202 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1009 "TeeJee.System.c"
			goto __catch97_g_error;
		}
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_ = g_strsplit (std_out, " ", 0);
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = _tmp7_;
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_[0];
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp11_ = _tmp10_;
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 203 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		uptime = _tmp11_;
#line 204 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp12_ = uptime;
#line 204 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		secs = double_parse (_tmp12_);
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = secs;
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (uptime);
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 205 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1044 "TeeJee.System.c"
	}
	goto __finally97;
	__catch97_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 208 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp13_ = e;
#line 208 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp14_ = _tmp13_->message;
#line 208 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = (gdouble) 0;
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 209 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1074 "TeeJee.System.c"
	}
	__finally97:
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error_);
#line 200 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return _tmp15_;
#line 1089 "TeeJee.System.c"
}


gchar*
tee_jee_system_get_desktop_name (void)
{
	gchar* result = NULL;
	gint pid = 0;
	gint _tmp0_;
	gint _tmp2_;
	gint _tmp4_;
	gint _tmp6_;
	gint _tmp8_;
	gint _tmp10_;
	gint _tmp12_;
	gchar* _tmp14_;
#line 217 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = -1;
#line 219 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("cinnamon");
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = pid;
#line 220 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp0_ > 0) {
#line 1114 "TeeJee.System.c"
		gchar* _tmp1_;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("Cinnamon");
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp1_;
#line 221 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1122 "TeeJee.System.c"
	}
#line 224 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("xfdesktop");
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = pid;
#line 225 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ > 0) {
#line 1130 "TeeJee.System.c"
		gchar* _tmp3_;
#line 226 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = g_strdup ("Xfce");
#line 226 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp3_;
#line 226 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1138 "TeeJee.System.c"
	}
#line 229 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("lxsession");
#line 230 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = pid;
#line 230 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp4_ > 0) {
#line 1146 "TeeJee.System.c"
		gchar* _tmp5_;
#line 231 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("LXDE");
#line 231 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp5_;
#line 231 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1154 "TeeJee.System.c"
	}
#line 234 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("gnome-shell");
#line 235 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = pid;
#line 235 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp6_ > 0) {
#line 1162 "TeeJee.System.c"
		gchar* _tmp7_;
#line 236 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = g_strdup ("Gnome");
#line 236 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp7_;
#line 236 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1170 "TeeJee.System.c"
	}
#line 239 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("wingpanel");
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp8_ = pid;
#line 240 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp8_ > 0) {
#line 1178 "TeeJee.System.c"
		gchar* _tmp9_;
#line 241 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = g_strdup ("Elementary");
#line 241 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp9_;
#line 241 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1186 "TeeJee.System.c"
	}
#line 244 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("unity-panel-service");
#line 245 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp10_ = pid;
#line 245 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp10_ > 0) {
#line 1194 "TeeJee.System.c"
		gchar* _tmp11_;
#line 246 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp11_ = g_strdup ("Unity");
#line 246 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp11_;
#line 246 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1202 "TeeJee.System.c"
	}
#line 249 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("plasma-desktop");
#line 250 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp12_ = pid;
#line 250 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp12_ > 0) {
#line 1210 "TeeJee.System.c"
		gchar* _tmp13_;
#line 251 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp13_ = g_strdup ("KDE");
#line 251 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp13_;
#line 251 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1218 "TeeJee.System.c"
	}
#line 254 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp14_ = g_strdup ("Unknown");
#line 254 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp14_;
#line 254 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1226 "TeeJee.System.c"
}


static gint
__lambda19_ (const gchar* a,
             const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 277 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strcmp0;
#line 277 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp0_ (a, b);
#line 277 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1246 "TeeJee.System.c"
}


static gint
___lambda19__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda19_ ((const gchar*) a, (const gchar*) b);
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1259 "TeeJee.System.c"
}


GeeArrayList*
tee_jee_system_list_dir_names (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	void* entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	void* _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError * _inner_error_ = NULL;
#line 257 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 258 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 258 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	list = _tmp0_;
#line 1283 "TeeJee.System.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 262 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 262 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		f_home = _tmp1_;
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = f_home;
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = _tmp3_;
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error_);
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = _tmp5_;
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp4_);
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		enumerator = _tmp6_;
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_object_unref0 (f_home);
#line 1316 "TeeJee.System.c"
			goto __catch98_g_error;
		}
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		while (TRUE) {
#line 1321 "TeeJee.System.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp8_ = enumerator;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp7_ = _tmp9_;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_object_unref0 (file);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_object_unref0 (enumerator);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_object_unref0 (f_home);
#line 1347 "TeeJee.System.c"
				goto __catch98_g_error;
			}
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp10_ = _tmp7_;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp7_ = NULL;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_object_unref0 (file);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			file = _tmp10_;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp11_ = file;
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			if (!(_tmp11_ != NULL)) {
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_object_unref0 (_tmp7_);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				break;
#line 1366 "TeeJee.System.c"
			}
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp12_ = file;
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 266 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			name = _tmp14_;
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp15_ = list;
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp16_ = name;
#line 268 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (name);
#line 265 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_object_unref0 (_tmp7_);
#line 1386 "TeeJee.System.c"
		}
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (file);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (enumerator);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (f_home);
#line 1394 "TeeJee.System.c"
	}
	goto __finally98;
	__catch98_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp17_ = e;
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp18_ = _tmp17_->message;
#line 272 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 1414 "TeeJee.System.c"
	}
	__finally98:
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_object_unref0 (list);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_clear_error (&_inner_error_);
#line 260 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return NULL;
#line 1427 "TeeJee.System.c"
	}
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare = ___lambda19__gcompare_data_func;
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 276 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp19_ = list;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp20_ = entry_compare;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp20__target = entry_compare_target;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare = NULL;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 279 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = list;
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare = NULL;
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 281 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1463 "TeeJee.System.c"
}


gint
tee_jee_system_get_display_width (void)
{
	gint result = 0;
	GdkScreen* _tmp0_;
#line 285 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 285 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = gdk_screen_get_width (_tmp0_);
#line 285 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1478 "TeeJee.System.c"
}


gint
tee_jee_system_get_display_height (void)
{
	gint result = 0;
	GdkScreen* _tmp0_;
#line 289 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 289 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = gdk_screen_get_height (_tmp0_);
#line 289 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1493 "TeeJee.System.c"
}


gboolean
tee_jee_system_check_internet_connectivity (void)
{
	gboolean result = FALSE;
	gboolean connected = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 295 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	connected = FALSE;
#line 296 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	connected = tee_jee_system_check_internet_connectivity_test1 ();
#line 298 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = connected;
#line 298 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp0_) {
#line 299 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = connected;
#line 299 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1516 "TeeJee.System.c"
	}
#line 302 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = connected;
#line 302 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (!_tmp1_) {
#line 303 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		connected = tee_jee_system_check_internet_connectivity_test2 ();
#line 1524 "TeeJee.System.c"
	}
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = connected;
#line 306 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1530 "TeeJee.System.c"
}


gboolean
tee_jee_system_check_internet_connectivity_test1 (void)
{
	gboolean result = FALSE;
	gint exit_code = 0;
	gchar* std_err = NULL;
	gchar* std_out = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
	gint _tmp7_;
#line 310 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	exit_code = -1;
#line 314 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("ping -q -w 1 -c 1 `ip r | grep default | cut -d ' ' -f 3`\n");
#line 314 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 315 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 315 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = g_strconcat (_tmp1_, "exit $?", NULL);
#line 315 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 315 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp2_;
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = cmd;
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = tee_jee_process_helper_exec_script_sync (_tmp3_, &_tmp4_, &_tmp5_, FALSE, FALSE, TRUE, FALSE);
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_out = _tmp4_;
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_err = _tmp5_;
#line 316 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	exit_code = _tmp6_;
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp7_ = exit_code;
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp7_ == 0;
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 318 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1590 "TeeJee.System.c"
}


gboolean
tee_jee_system_check_internet_connectivity_test2 (void)
{
	gboolean result = FALSE;
	gint exit_code = 0;
	gchar* std_err = NULL;
	gchar* std_out = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
	gint _tmp7_;
#line 322 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	exit_code = -1;
#line 326 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("ping -q -w 1 -c 1 google.com\n");
#line 326 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = g_strconcat (_tmp1_, "exit $?", NULL);
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 327 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp2_;
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = cmd;
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = tee_jee_process_helper_exec_script_sync (_tmp3_, &_tmp4_, &_tmp5_, FALSE, FALSE, TRUE, FALSE);
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_out = _tmp4_;
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	std_err = _tmp5_;
#line 328 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	exit_code = _tmp6_;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp7_ = exit_code;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp7_ == 0;
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 330 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1650 "TeeJee.System.c"
}


gboolean
tee_jee_system_shutdown (void)
{
	gboolean result = FALSE;
	gboolean _tmp7_ = FALSE;
	GError * _inner_error_ = NULL;
	{
		gchar** argv = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gint argv_length1;
		gint _argv_size_;
		GPid procId = 0;
		GPid _tmp4_ = 0;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = g_strdup ("shutdown");
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("-h");
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = g_strdup ("now");
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_[0] = _tmp0_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_[1] = _tmp1_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_[2] = _tmp2_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv = _tmp3_;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv_length1 = 3;
#line 338 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_argv_size_ = argv_length1;
#line 340 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_spawn_async (NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, &_inner_error_);
#line 340 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		procId = _tmp4_;
#line 340 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 340 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1698 "TeeJee.System.c"
			goto __catch99_g_error;
		}
#line 341 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = TRUE;
#line 341 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 341 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1707 "TeeJee.System.c"
	}
	goto __finally99;
	__catch99_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 337 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		e = _inner_error_;
#line 337 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_inner_error_ = NULL;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = e;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = _tmp5_->message;
#line 344 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 345 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = FALSE;
#line 345 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 345 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1731 "TeeJee.System.c"
	}
	__finally99:
#line 337 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 337 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error_);
#line 337 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return _tmp7_;
#line 1740 "TeeJee.System.c"
}


gboolean
tee_jee_system_command_exists (const gchar* command)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 349 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (command != NULL, FALSE);
#line 350 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path (command);
#line 350 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 1762 "TeeJee.System.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = strlen (_tmp3_);
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = _tmp5_ > 0;
#line 1774 "TeeJee.System.c"
	} else {
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 1778 "TeeJee.System.c"
	}
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp1_;
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 351 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1786 "TeeJee.System.c"
}


gboolean
tee_jee_system_xdg_open (const gchar* file,
                         const gchar* user)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 356 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 357 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 1811 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 1817 "TeeJee.System.c"
	} else {
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 1821 "TeeJee.System.c"
	}
#line 358 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 1825 "TeeJee.System.c"
		gchar* cmd = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		const gchar* _tmp14_;
		gint status = 0;
		const gchar* _tmp15_;
		gint _tmp16_;
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = tee_jee_file_system_escape_single_quote (file);
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = g_strdup_printf ("xdg-open '%s'", _tmp5_);
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 359 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		cmd = _tmp7_;
#line 360 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = strlen (user);
#line 360 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_;
#line 360 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (_tmp9_ > 0) {
#line 1855 "TeeJee.System.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp10_ = g_strdup_printf ("pkexec --user %s env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY ", user);
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp11_ = _tmp10_;
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp12_ = cmd;
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			cmd = _tmp13_;
#line 361 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (_tmp11_);
#line 1874 "TeeJee.System.c"
		}
#line 363 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp14_ = cmd;
#line 363 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		tee_jee_logging_log_debug (_tmp14_);
#line 364 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp15_ = cmd;
#line 364 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp15_);
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp16_ = status;
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp16_ == 0;
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 365 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 1894 "TeeJee.System.c"
	}
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = FALSE;
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 367 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 1902 "TeeJee.System.c"
}


gboolean
tee_jee_system_exo_open_folder (const gchar* dir_path,
                                gboolean xdg_open_try_first)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
#line 370 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 384 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (xdg_open_try_first) {
#line 1923 "TeeJee.System.c"
		gchar* _tmp0_;
		gboolean _tmp1_ = FALSE;
		const gchar* _tmp2_;
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp0_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 386 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		path = _tmp0_;
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = path;
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (_tmp2_ != NULL) {
#line 1937 "TeeJee.System.c"
			const gchar* _tmp3_;
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp3_ = path;
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 1943 "TeeJee.System.c"
		} else {
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp1_ = FALSE;
#line 1947 "TeeJee.System.c"
		}
#line 387 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (_tmp1_) {
#line 1951 "TeeJee.System.c"
			gchar* cmd = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp4_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp5_ = _tmp4_;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp6_ = g_strdup_printf ("xdg-open '%s'", _tmp5_);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp7_ = _tmp6_;
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (_tmp5_);
#line 388 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			cmd = _tmp7_;
#line 389 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp8_ = cmd;
#line 389 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			status = tee_jee_process_helper_exec_script_async (_tmp8_);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp9_ = status;
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			result = _tmp9_ == 0;
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (path);
#line 390 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			return result;
#line 1985 "TeeJee.System.c"
		}
	}
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp10_ = g_strdup ("nemo");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp11_ = g_strdup ("nautilus");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp12_ = g_strdup ("thunar");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp13_ = g_strdup ("pantheon-files");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp14_ = g_strdup ("marlin");
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_ = g_new0 (gchar*, 5 + 1);
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_[0] = _tmp10_;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_[1] = _tmp11_;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_[2] = _tmp12_;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_[3] = _tmp13_;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp15_[4] = _tmp14_;
#line 2010 "TeeJee.System.c"
	{
		gchar** app_name_collection = NULL;
		gint app_name_collection_length1 = 0;
		gint _app_name_collection_size_ = 0;
		gint app_name_it = 0;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		app_name_collection = _tmp15_;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		app_name_collection_length1 = 5;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		for (app_name_it = 0; app_name_it < 5; app_name_it = app_name_it + 1) {
#line 2022 "TeeJee.System.c"
			gchar* _tmp16_;
			gchar* app_name = NULL;
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp16_ = g_strdup (app_name_collection[app_name_it]);
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			app_name = _tmp16_;
#line 2029 "TeeJee.System.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gboolean _tmp19_ = FALSE;
				const gchar* _tmp20_;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp17_ = app_name;
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp18_ = tee_jee_process_helper_get_cmd_path (_tmp17_);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_free0 (path);
#line 397 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				path = _tmp18_;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp20_ = path;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp20_ != NULL) {
#line 2047 "TeeJee.System.c"
					const gchar* _tmp21_;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp21_ = path;
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp19_ = g_strcmp0 (_tmp21_, "") != 0;
#line 2053 "TeeJee.System.c"
				} else {
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp19_ = FALSE;
#line 2057 "TeeJee.System.c"
				}
#line 398 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp19_) {
#line 2061 "TeeJee.System.c"
					gchar* cmd = NULL;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					gint _tmp28_;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp22_ = app_name;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp23_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp24_ = _tmp23_;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp25_ = g_strdup_printf ("%s '%s'", _tmp22_, _tmp24_);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp26_ = _tmp25_;
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (_tmp24_);
#line 399 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					cmd = _tmp26_;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp27_ = cmd;
#line 400 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					status = tee_jee_process_helper_exec_script_async (_tmp27_);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp28_ = status;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					result = _tmp28_ == 0;
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (app_name);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					app_name_collection = (_vala_array_free (app_name_collection, app_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (path);
#line 401 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					return result;
#line 2102 "TeeJee.System.c"
				}
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_g_free0 (app_name);
#line 2106 "TeeJee.System.c"
			}
		}
#line 394 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		app_name_collection = (_vala_array_free (app_name_collection, app_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2111 "TeeJee.System.c"
	}
#line 405 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (xdg_open_try_first == FALSE) {
#line 2115 "TeeJee.System.c"
		gchar* _tmp29_;
		gboolean _tmp30_ = FALSE;
		const gchar* _tmp31_;
#line 407 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp29_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 407 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 407 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		path = _tmp29_;
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp31_ = path;
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (_tmp31_ != NULL) {
#line 2129 "TeeJee.System.c"
			const gchar* _tmp32_;
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp32_ = path;
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp30_ = g_strcmp0 (_tmp32_, "") != 0;
#line 2135 "TeeJee.System.c"
		} else {
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp30_ = FALSE;
#line 2139 "TeeJee.System.c"
		}
#line 408 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (_tmp30_) {
#line 2143 "TeeJee.System.c"
			gchar* cmd = NULL;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			const gchar* _tmp37_;
			gint _tmp38_;
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp33_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp34_ = _tmp33_;
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp35_ = g_strdup_printf ("xdg-open '%s'", _tmp34_);
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp36_ = _tmp35_;
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (_tmp34_);
#line 409 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			cmd = _tmp36_;
#line 410 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp37_ = cmd;
#line 410 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			status = tee_jee_process_helper_exec_script_async (_tmp37_);
#line 411 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp38_ = status;
#line 411 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			result = _tmp38_ == 0;
#line 411 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 411 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (path);
#line 411 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			return result;
#line 2177 "TeeJee.System.c"
		}
	}
#line 415 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = FALSE;
#line 415 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 415 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2186 "TeeJee.System.c"
}


gboolean
tee_jee_system_exo_open_textfile (const gchar* txt_file)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
#line 418 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (txt_file != NULL, FALSE);
#line 426 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("exo-open");
#line 426 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 426 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 2215 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 2221 "TeeJee.System.c"
	} else {
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 2225 "TeeJee.System.c"
	}
#line 427 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 2229 "TeeJee.System.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = tee_jee_file_system_escape_single_quote (txt_file);
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = g_strdup_printf ("exo-open '%s'", _tmp5_);
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		cmd = _tmp6_;
#line 428 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 429 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = cmd;
#line 429 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp7_);
#line 430 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = status;
#line 430 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp8_ == 0;
#line 430 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 430 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 430 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 2261 "TeeJee.System.c"
	}
#line 433 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp9_ = tee_jee_process_helper_get_cmd_path ("gedit");
#line 433 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 433 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp9_;
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp11_ = path;
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp11_ != NULL) {
#line 2273 "TeeJee.System.c"
		const gchar* _tmp12_;
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp12_ = path;
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, "") != 0;
#line 2279 "TeeJee.System.c"
	} else {
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = FALSE;
#line 2283 "TeeJee.System.c"
	}
#line 434 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp10_) {
#line 2287 "TeeJee.System.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gint _tmp17_;
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp13_ = tee_jee_file_system_escape_single_quote (txt_file);
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp14_ = _tmp13_;
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp15_ = g_strdup_printf ("gedit --new-document '%s'", _tmp14_);
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		cmd = _tmp15_;
#line 435 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp14_);
#line 436 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp16_ = cmd;
#line 436 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp16_);
#line 437 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp17_ = status;
#line 437 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp17_ == 0;
#line 437 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 437 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 437 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 2319 "TeeJee.System.c"
	}
#line 440 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = FALSE;
#line 440 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 440 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 440 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2329 "TeeJee.System.c"
}


gboolean
tee_jee_system_exo_open_url (const gchar* url)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gchar* _tmp18_;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp20_;
#line 443 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 451 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("exo-open");
#line 451 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 451 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 2360 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 2366 "TeeJee.System.c"
	} else {
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 2370 "TeeJee.System.c"
	}
#line 452 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 2374 "TeeJee.System.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gint _tmp8_;
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp4_ = g_strconcat ("exo-open \"", url, NULL);
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = g_strconcat (_tmp5_, "\"", NULL);
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp7_);
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp7_);
#line 453 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 454 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp8_ = status;
#line 454 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp8_ == 0;
#line 454 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 454 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 2402 "TeeJee.System.c"
	}
#line 457 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp9_ = tee_jee_process_helper_get_cmd_path ("firefox");
#line 457 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 457 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp9_;
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp11_ = path;
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp11_ != NULL) {
#line 2414 "TeeJee.System.c"
		const gchar* _tmp12_;
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp12_ = path;
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, "") != 0;
#line 2420 "TeeJee.System.c"
	} else {
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp10_ = FALSE;
#line 2424 "TeeJee.System.c"
	}
#line 458 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp10_) {
#line 2428 "TeeJee.System.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint _tmp17_;
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp13_ = g_strconcat ("firefox \"", url, NULL);
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp14_ = _tmp13_;
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp15_ = g_strconcat (_tmp14_, "\"", NULL);
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp16_ = _tmp15_;
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp16_);
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp16_);
#line 459 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp14_);
#line 460 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp17_ = status;
#line 460 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp17_ == 0;
#line 460 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 460 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 2456 "TeeJee.System.c"
	}
#line 463 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp18_ = tee_jee_process_helper_get_cmd_path ("chromium-browser");
#line 463 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 463 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	path = _tmp18_;
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp20_ = path;
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp20_ != NULL) {
#line 2468 "TeeJee.System.c"
		const gchar* _tmp21_;
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp21_ = path;
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp19_ = g_strcmp0 (_tmp21_, "") != 0;
#line 2474 "TeeJee.System.c"
	} else {
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp19_ = FALSE;
#line 2478 "TeeJee.System.c"
	}
#line 464 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (_tmp19_) {
#line 2482 "TeeJee.System.c"
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gint _tmp26_;
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp22_ = g_strconcat ("chromium-browser \"", url, NULL);
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp23_ = _tmp22_;
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp24_ = g_strconcat (_tmp23_, "\"", NULL);
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp25_ = _tmp24_;
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp25_);
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp25_);
#line 465 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (_tmp23_);
#line 466 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp26_ = status;
#line 466 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		result = _tmp26_ == 0;
#line 466 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 466 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		return result;
#line 2510 "TeeJee.System.c"
	}
#line 469 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = FALSE;
#line 469 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 469 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2518 "TeeJee.System.c"
}


gboolean
tee_jee_system_using_efi_boot (void)
{
	gboolean result = FALSE;
#line 477 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = tee_jee_file_system_dir_exists ("/sys/firmware/efi");
#line 477 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2530 "TeeJee.System.c"
}


void
tee_jee_system_open_terminal_window (const gchar* terminal_emulator,
                                     const gchar* working_dir,
                                     const gchar* script_file_to_execute,
                                     gboolean run_as_admin)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* term = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GQuark _tmp14_ = 0U;
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	static GQuark _tmp13_label0 = 0;
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	static GQuark _tmp13_label1 = 0;
#line 2555 "TeeJee.System.c"
	const gchar* _tmp31_;
	const gchar* _tmp32_;
#line 480 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_if_fail (terminal_emulator != NULL);
#line 480 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_if_fail (working_dir != NULL);
#line 480 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_if_fail (script_file_to_execute != NULL);
#line 486 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 486 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 487 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (run_as_admin) {
#line 2570 "TeeJee.System.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 488 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp1_ = cmd;
#line 488 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp2_ = g_strconcat (_tmp1_, "pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY ", NULL);
#line 488 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 488 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		cmd = _tmp2_;
#line 2581 "TeeJee.System.c"
	}
#line 491 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = g_strdup (terminal_emulator);
#line 491 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	term = _tmp3_;
#line 492 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = term;
#line 492 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (!tee_jee_system_command_exists (_tmp4_)) {
#line 2591 "TeeJee.System.c"
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 493 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("gnome-terminal");
#line 493 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_g_free0 (term);
#line 493 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		term = _tmp5_;
#line 494 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		_tmp6_ = term;
#line 494 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		if (!tee_jee_system_command_exists (_tmp6_)) {
#line 2604 "TeeJee.System.c"
			gchar* _tmp7_;
#line 495 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_tmp7_ = g_strdup ("xfce4-terminal");
#line 495 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			_g_free0 (term);
#line 495 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
			term = _tmp7_;
#line 2612 "TeeJee.System.c"
		}
	}
#line 499 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp8_ = cmd;
#line 499 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp9_ = term;
#line 499 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 499 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 499 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	cmd = _tmp10_;
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp11_ = term;
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp12_ = _tmp11_;
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if ((_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("gnome-terminal")))) || (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("xfce4-terminal"))))) {
#line 501 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		switch (0) {
#line 2635 "TeeJee.System.c"
			default:
			{
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp23_;
				gint _tmp24_;
#line 504 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp15_ = strlen (working_dir);
#line 504 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp16_ = _tmp15_;
#line 504 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp16_ > 0) {
#line 2648 "TeeJee.System.c"
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp17_ = cmd;
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp18_ = tee_jee_file_system_escape_single_quote (working_dir);
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp19_ = _tmp18_;
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp20_ = g_strdup_printf (" --working-directory='%s'", _tmp19_);
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp21_ = _tmp20_;
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp22_ = g_strconcat (_tmp17_, _tmp21_, NULL);
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					cmd = _tmp22_;
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (_tmp21_);
#line 505 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (_tmp19_);
#line 2675 "TeeJee.System.c"
				}
#line 507 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp23_ = strlen (script_file_to_execute);
#line 507 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				_tmp24_ = _tmp23_;
#line 507 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				if (_tmp24_ > 0) {
#line 2683 "TeeJee.System.c"
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp25_ = cmd;
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp26_ = tee_jee_file_system_escape_single_quote (script_file_to_execute);
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp27_ = _tmp26_;
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp28_ = g_strdup_printf (" -e '%s\n; echo Press ENTER to exit... ; read dummy;'", _tmp27_);
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp29_ = _tmp28_;
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					cmd = _tmp30_;
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (_tmp29_);
#line 508 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
					_g_free0 (_tmp27_);
#line 2710 "TeeJee.System.c"
				}
#line 510 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
				break;
#line 2714 "TeeJee.System.c"
			}
		}
	}
#line 513 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp31_ = cmd;
#line 513 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	tee_jee_logging_log_debug (_tmp31_);
#line 514 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp32_ = cmd;
#line 514 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	tee_jee_process_helper_exec_script_async (_tmp32_);
#line 480 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (term);
#line 480 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 2730 "TeeJee.System.c"
}


GTimer*
tee_jee_system_timer_start (void)
{
	GTimer* result = NULL;
	GTimer* timer = NULL;
	GTimer* _tmp0_;
#line 520 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp0_ = g_timer_new ();
#line 520 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	timer = _tmp0_;
#line 521 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_timer_start (timer);
#line 522 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = timer;
#line 522 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2750 "TeeJee.System.c"
}


gulong
tee_jee_system_timer_elapsed (GTimer* timer,
                              gboolean stop)
{
	gulong result = 0UL;
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gulong _tmp3_;
#line 525 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (timer != NULL, 0UL);
#line 528 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 528 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 528 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 529 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (stop) {
#line 530 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2777 "TeeJee.System.c"
	}
#line 532 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = seconds;
#line 532 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = microseconds;
#line 532 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = (gulong) ((_tmp2_ * 1000) + (_tmp3_ / 1000));
#line 532 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2787 "TeeJee.System.c"
}


void
tee_jee_system_sleep (gint milliseconds)
{
#line 536 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_usleep (((gulong) milliseconds) * 1000);
#line 2796 "TeeJee.System.c"
}


gchar*
tee_jee_system_timer_elapsed_string (GTimer* timer,
                                     gboolean stop)
{
	gchar* result = NULL;
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gulong _tmp3_;
	gchar* _tmp4_;
#line 539 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_val_if_fail (timer != NULL, NULL);
#line 542 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 542 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 542 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 543 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (stop) {
#line 544 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2824 "TeeJee.System.c"
	}
#line 546 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = seconds;
#line 546 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = microseconds;
#line 546 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = g_strdup_printf ("%.0f ms", (_tmp2_ * 1000) + (_tmp3_ / 1000));
#line 546 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	result = _tmp4_;
#line 546 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	return result;
#line 2836 "TeeJee.System.c"
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 2868 "TeeJee.System.c"
}


void
tee_jee_system_timer_elapsed_print (GTimer* timer,
                                    gboolean stop)
{
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gulong _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 549 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_if_fail (timer != NULL);
#line 552 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 552 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 552 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 553 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	if (stop) {
#line 554 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2898 "TeeJee.System.c"
	}
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp2_ = seconds;
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp3_ = double_to_string (_tmp2_);
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp4_ = _tmp3_;
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp5_ = microseconds;
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp6_ = g_strdup_printf ("%s %lu\n", _tmp4_, _tmp5_);
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_tmp7_ = _tmp6_;
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (_tmp7_);
#line 556 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	_g_free0 (_tmp4_);
#line 2918 "TeeJee.System.c"
}


void
tee_jee_system_set_numeric_locale (const gchar* type)
{
#line 560 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	g_return_if_fail (type != NULL);
#line 561 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	setlocale (LC_NUMERIC, type);
#line 562 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	setlocale (LC_COLLATE, type);
#line 563 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/TeeJee.System.vala"
	setlocale (LC_TIME, type);
#line 2933 "TeeJee.System.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



